package Conquest;

import java.awt.Color;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.lang.reflect.Method;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Random;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.filechooser.FileFilter;
import javax.swing.table.TableModel;

import Conquest.Type.FieldInfo;
import Conquest.Type.Property;
import Conquest.Type.Table;
import Conquest.Type.TableInfo;
import Conquest.Type.CurrentSPQLExecution;


/**
 * La classe principale, ovvero il control di Conquest, che contiene
 * tutti i Workers, le Utility e gli altri metodi. Questa classe mantiene in 
 * se tutti dati di Conquest fatta eccezione di quelli grafici che vengon delegati 
 * ad una istanza della interface inizializzata nel costruttore.
 */
public class Conquest {
	
	public Interface Gui = null;
	public SpqlManager Spql= null;
	public java.util.ArrayList jList = new java.util.ArrayList();
	public Connection connection = null;
	public Statement statement = null;
	public DatabaseMetaData infoDb = null;
	public String DB_URL = "";
	public String DB_DRIVER = "";
	public String DB_PASSWORD = "";
	public String DB_UTENTE = ""; 
	public String[] SEL_TYPES = {"TABLE", "VIEW"};
	public Hashtable constraint = new Hashtable();
	public ArrayList constraintOrder = new ArrayList();
	public Hashtable operator = new Hashtable();
	public int idtable = -1;
	public String progressBarTitle = null;
	public int progressBarMax = 0;
	public int progressBarCur = 0;
	public Hashtable cacheTableInfo = null;
	public ArrayList Select = new ArrayList();
	public ArrayList TransactionTot = new ArrayList();
	public ArrayList ItemTot = new ArrayList();
	public ArrayList AttributeTot = new ArrayList();
	public boolean validquery = false;
	public boolean validdataset = false;
	public float RangeGraph = 0;
	public Hashtable InfoGraph = null;
	public float MaxGraph = 0;
	public int typeGraph =0;
	public Table selJList = null;  
	public int selJListField = -1;  
	public boolean ChangeDataset = true;
	public boolean ChangeTable = true;
	public boolean ChangeGraph = true;
	public Image cacheGraph = null;
	public ArrayList ErrorMessage = new ArrayList(0);
	public int working = 0;
	public Exec pr = null;
	public Executor exe = null;
	public Miner mi = null;
	public Cacher ca = null;
	public Connecter co = null;
	public DatasetGenerator da = null;
	public InfoVisualizator inf = null;
	public TableVisualizator tab = null;
	public Materializer ma = null;
	public Discretizator di = null;
	public ArrayList Discretization = null;
	public CurrentSPQLExecution cSPQL = (new Type()).new CurrentSPQLExecution();
	public int currentRulesMaxLenght = 0;
	public ArrayList From = null;
	public int materializeType = 0;
	public boolean Drag = false;
	public Point dragPoint = null;
	public String dbmode= "";
	public JTable orderTable = null;
	public JScrollPane orderScroll=null;
	public int orderId = 0;
	public int orderId2 = 0;
	public Object orderColumns[] = null;
	public int orderSortFrom = 0;
	public double zoom = 1;
	public int mxGraph = 0;
	public int myGraph = 0;
	public int moveGraph = 0;
	public Hashtable resolveAttribute = new Hashtable(0);
	public boolean browserNameMapping = true;	
	public boolean nameLinked = false;
	public boolean aConstraint = false;
	public int introGap=0;
	public Hashtable jListProperty = new Hashtable(0);
	static final public String ItemView = "Item view";
	static final public String ItemsetView = "Itemset view";
	static final public String AFieldName = "Add field name";
	static final public String RFieldName = "Remove field name";
	public final static ImageIcon PrimaryIcon = new javax.swing.ImageIcon("Image/Primary.gif");
	public final static ImageIcon ForeignIcon = new javax.swing.ImageIcon("Image/Foreign.gif");
	public final static ImageIcon ConflictIcon = new javax.swing.ImageIcon("Image/Conflict.gif");
	public final static ImageIcon ExConflictIcon = new javax.swing.ImageIcon("Image/ExConflict.gif");
	public final static ImageIcon RollupIcon = new javax.swing.ImageIcon("Image/Rollup.gif");
	public final static ImageIcon UnivocIcon = new javax.swing.ImageIcon("Image/Univoc.gif");
	public final static ImageIcon CreatedIconBrowser = new javax.swing.ImageIcon("Image/CreatedB.gif");
	public final static ImageIcon CreatedIconRules = new javax.swing.ImageIcon("Image/CreatedR.gif");
	public final static ImageIcon TableListCreatedIconBrowser = new javax.swing.ImageIcon("Image/TCreatedB.gif");
	public final static ImageIcon TableListCreatedIconRules = new javax.swing.ImageIcon("Image/TCreatedR.gif");
	public final static ImageIcon allDistinctIcon = new javax.swing.ImageIcon("Image/AllDistinct.gif");
	public final static ImageIcon LoadingIcon = new javax.swing.ImageIcon("Image/LoadingIcon.gif");
	public final static ImageIcon LoadedIcon = new javax.swing.ImageIcon("Image/LoadedIcon.gif");
	public final static Image aniConquest = Toolkit.getDefaultToolkit().getImage("Image/Conquest.gif");
	public final static String Marker = "\\(.*\\)";
	public final static int fromBrowser = 1;
	public final static int fromRules = 2;
	public final static int MAXCAKE=10;
	public final static boolean AUTOUPDATE=false;
	public final static int LIMITINFO =5000;
	public final DecimalFormat df = new DecimalFormat("#.##");
	
	
	/**
	 * Imposta e trasferisce i dati di una tabella, presente in cache, 
	 * allinterno del pannello di visualizzazione della tabella e le 
	 * informazioni generali sulla tabella correntemente selezionata 
	 * nel pannello Table Information.
	 */
	public class TableVisualizator extends Thread
	{
		
		public void run ()
		{
			tableVisual();
		}
		public void tableVisual()
		{
			try
			{
				if ((cacheTableInfo!=null)&&(cacheTableInfo.containsKey(selJList.Title))&&(ChangeTable))
				{
					ChangeTable=false;
					String dataCache = "";
					Gui.jButton38.setVisible(false);
					try
					{
						ParserXML XML = new ParserXML();
						String nameInfo = "Info"+DB_URL.hashCode()+"_"+selJList.Title+".info";
						XML.XMLRead(".\\TableInfo\\"+nameInfo);
						dataCache = "Original SPQL query:"+(String) XML.getData("query")+
						"\nOther Mining Information:"+(String) XML.getData("infoFinded");
						if (XML.getData("confidence").compareTo("null")!=0)
							dataCache+="\n\nOriginal Rules patameters:\nMinimum Confidence: "+XML.getData("confidence").replaceAll("\n","");
						Gui.jButton38.setVisible(true);
					} catch (Exception ex) {}
					
					Gui.jScrollPane1.setViewportView(Gui.getJTable(((TableInfo) cacheTableInfo.get(selJList.Title)).Data,((TableInfo) cacheTableInfo.get(selJList.Title)).Columns));
					Gui.jTextPane4.setText("Number of rows: "+((TableInfo) cacheTableInfo.get(selJList.Title)).nelements
							+"\n"+((TableInfo) cacheTableInfo.get(selJList.Title)).listType+"\n"+
							dataCache);
					Gui.jScrollPane1.repaint();
					Gui.jTextPane4.repaint();
				}
			}catch (Exception ex) {}
			working--;
		} 
	}
	
	/**
	 Questo componente carica in memoria il contenuto delle tabelle per un accesso 
	 rapido da parte di ConQueSt, inoltre calcola informazioni sui vari campi 
	 delle tabelle (come massimo, minimo, media, valori distinti, ecc..) 
	 determinando anche quali sono i campi univoci della tabella. 
	 */
	public class Cacher extends Thread 
	{
		
		public boolean interrupt=false;
		public void interrupt()
		{
			interrupt = true;
		}
		
		public void run()
		{
			cache();
		}
		
		public void cache()
		{
			try
			{
				for (int i=0; i<jList.size(); i++)
				{
					updateTableList();
					if (interrupt) return;
					progressBarTitle="Reading Table: "+((Table) jList.get(i)).Title;
					progressBarMax=jList.size()+1;
					progressBarCur=i;
					try
					{
						ParserXML XML = new ParserXML();
						String nameInfo = "Info"+DB_URL.hashCode()+"_"+((Table) jList.get(i)).Title+".info";
						XML.XMLRead(".\\TableInfo\\"+nameInfo);
						if (XML.getData("confidence").compareTo("null")==0) ((Table) jList.get(i)).created=fromBrowser;
						else ((Table) jList.get(i)).created=fromRules;
					} catch (Exception ex) {}
					
					if (cacheTableInfo.containsKey(((Table) jList.get(i)).Title)==false)
					{
						String typelist = "";
						ResultSet tableinfo = infoDb.getColumns(null,null,((Table) jList.get(i)).Title,null);
						while (tableinfo.next())
						{
							int n=tableinfo.getInt(5);
							String name = "String";
							if ( (n==4) || (n==5) ||(n==-6) ) name = "Integer";
							if ( (n==-5) ||	(n==3) || (n==8) ||	(n==6) || (n==2) ) name = "Double";
							typelist=typelist+tableinfo.getString(4)+": "+name+"\n";
						}
						Gui.jProgressBar.setValue(Gui.jProgressBar.getValue()+1);
						Gui.jDesktopPane.repaint();
						if (dbmode.compareTo("MSAccess")==0) statement.execute("SELECT * FROM ["+((Table) (jList.get(i))).Title+"];"); 
						else statement.execute("SELECT * FROM "+((Table) (jList.get(i))).Title+";");
						ResultSet result = statement.getResultSet();
						int numberOfColumns = result.getMetaData().getColumnCount();
						int numberOfRows = 0;
						ArrayList a = new ArrayList();
						double max[] = new double[numberOfColumns];
						double min[] = new double[numberOfColumns];
						double avg[] = new double[numberOfColumns];
						boolean nr[] = new boolean[numberOfColumns];
						Hashtable Graph[] = new Hashtable[numberOfColumns];
						float Graphmax[] = new float[numberOfColumns];
						for (int o=0; o<numberOfColumns; o++)
						{
							nr[o]=false;
							Graph[o] = new Hashtable(0);
						}
						int nline=0;
						while (result.next()) 
						{
							nline++;
							if (nline<LIMITINFO) a.add(new ArrayList());
							for (int o=1; o<=numberOfColumns; o++)
							{
								String data = result.getString(o);
								if (data==null) data="";
								if (Graph[o-1].containsKey(data)==false)
								{
									if (Graphmax[o-1]==0) Graphmax[o-1]=1;
									Graph[o-1].put(data,new Integer(1));
								}
								else
								{
									int count = (((Integer) Graph[o-1].get(data)).intValue()+1);
									Graph[o-1].put(data,new Integer(count));
									if (Graphmax[o-1]<count+1) Graphmax[o-1]=count+1;
								}
								
								if (nr[o-1]==false)
								{
									try
									{
										double val = new Double(data).doubleValue();
										avg[o-1] +=val;
										if (val>max[o-1]) max[o-1] =val;
										if (val<min[o-1]) min[o-1] =val;
										
									} catch (Exception exc) {nr[o-1]=true;}
								}
								int type = 0;
								int n = result.getMetaData().getColumnType(o); 
								if ( (n==4) || (n==5) ||(n==-6) ) type=1;
								if ( (n==-5) ||	(n==3) || (n==8) ||	(n==6) || (n==2) ) type=2;
								if (nline<LIMITINFO) 
								{
									try
									{
										if (type==0) ((ArrayList) a.get(a.size()-1)).add(data);
										if (type==1) ((ArrayList) a.get(a.size()-1)).add(new Integer(data));
										if (type==2) ((ArrayList) a.get(a.size()-1)).add(new Double(data));
									} catch (Exception ec) 
									{
										if (type==0) ((ArrayList) a.get(a.size()-1)).add("");
										if (type==1) ((ArrayList) a.get(a.size()-1)).add(new Integer(0));
										if (type==2) ((ArrayList) a.get(a.size()-1)).add(new Double(0));
									}
								}
							}
							numberOfRows++;
						}
						if (interrupt) return;
						Object Data[][] = new Object[a.size()][numberOfColumns];
						for (int o=0; o<a.size(); o++)
							Data[o] = ((ArrayList) a.get(o)).toArray();
						Object Columns[] = new Object[numberOfColumns];
						for (int o=1; o<=numberOfColumns; o++)
							Columns[o-1] = result.getMetaData().getColumnName(o);
						TableInfo ti = (new Type()).new TableInfo();
						ti.Data=Data;
						ti.Columns=Columns;
						ti.nelements=numberOfRows;
						ti.listType=typelist;
						ti.recalculate=false;
						for (int o=0; o<numberOfColumns; o++)
						{
							avg[o]= avg[o]/numberOfRows;
							FieldInfo fi = (new Type()).new FieldInfo();
							fi.max=max[o];
							fi.min=min[o];
							fi.avg=avg[o];
							fi.nr=nr[o];
							fi.InfoGraph=Graph[o];
							fi.MaxGraph=Graphmax[o];
							if (Graph[o].size()==numberOfRows)
								((Table) jList.get(i)).UnivocKey.add(Columns[o]);
							ti.Field.put(Columns[o],fi);
						}
						cacheTableInfo.put(((Table) (jList.get(i))).Title,ti);
					}
					else
					{
						TableInfo ti = (TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title);
						for (int c=0; c<ti.Columns.length; c++)
						{
							FieldInfo fi = (FieldInfo) ti.Field.get(ti.Columns[c]);
							if (fi.InfoGraph.size()==ti.nelements)
								((Table) jList.get(i)).UnivocKey.add(ti.Columns[c]);
						}
					}
					if (jListProperty.containsKey(((Table) jList.get(i)).Title))
						((Table) jList.get(i)).setVisible(((Property) jListProperty.get(((Table) jList.get(i)).Title)).visible);
					else 
						((Table) jList.get(i)).setVisible(true);
				}
			} catch (Exception ex) {}
			working--;
		}
	}
	
	/**
	 Connette ConQueSt al database di cui sono stati inseriti i dati, 
	 ovvero locazione, tipologia, username e password e ne ricava 
	 la struttura in tabelle (istanziando vari Table, componente 
	 interface visto in precedenza) e i metadati generali relativi 
	 ad esse (chiavi primarie, chiave esterne)
	 */
	public class Connecter extends Thread
	{
		
		public boolean resetCache=true;
		public boolean stillworking = true;
		public boolean interrupt=false;
		
		public void interrupt()
		{
			interrupt = true;
		}
		
		public void run()
		{
			stillworking = true;
			connect();
			stillworking = false;		
		}
		
		public void connect() 
		{
			Gui.jWarning.clearWarning();
			ChangeTable=true;
			ChangeDataset=true;
			selJList=null;
			try {
				jList.clear();
				Gui.jDesktopPane.removeAll();
				updateTableList();
				Gui.jDesktopPane.repaint();
				if (resetCache)	cacheTableInfo = new Hashtable();
				Class.forName(DB_DRIVER);
				connection = DriverManager.getConnection(DB_URL,DB_UTENTE,DB_PASSWORD);
				statement = connection.createStatement();
				infoDb = connection.getMetaData();
				ResultSet tables = infoDb.getTables(null,null,"%",SEL_TYPES);
				progressBarMax=0;
				while (tables.next()) 
					progressBarMax++;
				progressBarTitle="Retriving Tables...";
				progressBarMax++;
				progressBarCur=0;
				tables = infoDb.getTables(null,null,"%",SEL_TYPES);
				while (tables.next()) {
					if (interrupt) return;
					String title = tables.getString(3);
					progressBarCur++;
					ResultSet tableinfo = infoDb.getColumns(null,null,title,null);
					java.util.Vector l = new java.util.Vector();
					if (interrupt) return;
					Gui.jDesktopPane.add(createJList());
					updateTableList();
					((Table) jList.get(jList.size()-1)).Title=title;
					((Table) jList.get(jList.size()-1)).setVisible(false);
					l.add(title);
					int size=((JList) jList.get(jList.size()-1)).getFontMetrics(((JList) jList.get(jList.size()-1)).getFont()).getHeight();
					int maxlenght = (l.get(l.size()-1)).toString().length();
					while (tableinfo.next())
					{
						l.add(tableinfo.getString(4));
						if (maxlenght<(l.get(l.size()-1)).toString().length()) maxlenght = (l.get(l.size()-1)).toString().length();
						size+=((JList) jList.get(jList.size()-1)).getFontMetrics(((JList) jList.get(jList.size()-1)).getFont()).getHeight();
					}
					maxlenght = maxlenght*((JList) jList.get(jList.size()-1)).getFontMetrics(((JList) jList.get(jList.size()-1)).getFont()).getWidths()[0]+20;
					((JList) jList.get(jList.size()-1)).setListData(l);
					
					if (jListProperty.containsKey(((Table) jList.get(jList.size()-1)).Title))
					{
						Property tmp = (Property) jListProperty.get(((Table) jList.get(jList.size()-1)).Title);
						((Table) jList.get(jList.size()-1)).setSize(maxlenght,size);
						((Table) jList.get(jList.size()-1)).setLocation(tmp.location);
						((Table) jList.get(jList.size()-1)).rollup = tmp.rollup;
						if (tmp.rollup) minimizeTable(((Table) jList.get(jList.size()-1)));
						else maximizeTable(((Table) jList.get(jList.size()-1)));
					}
					else
					{
						Random rand = new Random();
						try
						{
							((JList) jList.get(jList.size()-1)).setBounds(rand.nextInt(Gui.jDesktopPane.getWidth()-maxlenght),rand.nextInt(Gui.jDesktopPane.getHeight()-size),maxlenght,size);
						} catch(Exception ex)
						{
							((JList) jList.get(jList.size()-1)).setBounds(rand.nextInt(10),rand.nextInt(10),maxlenght,size);
						}
						minimizeTable(((Table) jList.get(jList.size()-1)));
						Property tmp = (new Type()).new Property();
						tmp.rollup=((Table) jList.get(jList.size()-1)).rollup;
						tmp.location=((Table) jList.get(jList.size()-1)).getLocation();
						tmp.visible= true;
						jListProperty.put(((Table) jList.get(jList.size()-1)).Title,tmp);
					}
					try
					{
						tableinfo = infoDb.getPrimaryKeys(null,null,title);
						while (tableinfo.next()) ((Table) jList.get(jList.size()-1)).PrimaryKey.add(tableinfo.getString(4));
						tableinfo = infoDb.getImportedKeys(null,null,title);
						while (tableinfo.next()) 
						{ 
							if (interrupt) return;
							((Table) jList.get(jList.size()-1)).ForeignKey.add(tableinfo.getString(8));
							((Table) jList.get(jList.size()-1)).ForeignTable.add(tableinfo.getString(3));
							((Table) jList.get(jList.size()-1)).ForeignPrimary.add(tableinfo.getString(4));
						}
					} catch (SQLException sqlex) {
						try
						{
							ResultSet index = infoDb.getIndexInfo(null,null,title, true, true);
							while (index.next() )
							{
								String ind = index.getString(9);
								if (ind!=null) ((Table) jList.get(jList.size()-1)).PrimaryKey.add(ind);
							}
						} catch (Exception ex) {}
					}
				}
				String dbshow = "Number of Tables: "+jList.size()+"\n"+ 
				"Product Name: "+infoDb.getDatabaseProductName()+" \n"+
				"Product Version: "+infoDb.getDatabaseProductVersion()+" \n"+
				"Url : " + DB_URL+ " \n\n";
				Gui.jTextPane2.setText(dbshow);
				
				if ((nameLinked)||(dbmode.compareTo("MSAccess")==0)) createNameLink();
				Gui.jDesktopPane.repaint();
				if (interrupt) return;
				ca = new Cacher();
				ca.cache();
				if (interrupt) return;
				Gui.jMasterPanel.repaint();
			} catch (Exception ee) {Gui.jWarning.setWarning(2,true); ee.printStackTrace();}
			if (interrupt) return;
			Gui.jDesktopPane.repaint();
			working--;
			parser();
			if (dbmode.compareTo("MSAccess")==0) Gui.jWarning.setWarning(6,true);
			updateTableList();
		}
	}
	
	/**
	 Esegue materialmente la query corrente per estrarre una vista 
	 dello strato pre-processing. Pu essere avviato in due modalit: 
	 preview o complete. Nella prima esegue il pre-processing 
	 con una finestra sul dataset limitata e visualizza il contenuto 
	 nel mining view panel, nella seconda invece esegue 
	 il pre-processing vero e proprio e genera i file del dataset. 
	 */
	public class DatasetGenerator extends Thread
	{
		int limit = 0;
		boolean specialmode = false;
		String name = null;
		String attname = null;
		boolean okresult = false;
		boolean MiningView = false;
		public boolean interrupt=false;
		boolean onlyAttribute=false;
		
		public int fromCache()
		{
			java.io.File dir = new java.io.File(".\\Dataset\\");
			String[] cacheMine = dir.list();
			int ok = 0;
			int attok = 0;
			String datasetName = createNameDataset(false);	
			String extAtt = createNameAttribute();
			for (int i=0; i<cacheMine.length; i++)
			{
				if (cacheMine[i].compareTo(datasetName+".txt")==0) ok++;
				if (cacheMine[i].compareTo(datasetName+"_"+extAtt+".att")==0) attok++;
				if (cacheMine[i].compareTo(datasetName+".imap")==0) ok++;
				if (cacheMine[i].compareTo(datasetName+"_"+extAtt+".amap")==0) attok++;
				if (cacheMine[i].compareTo(datasetName+".desc")==0) ok++;
			}
			if (ok!=3)
			{
				return 2;
			} else 
				if (attok!=2)
					return 1;
			return 0;
		}
		
		
		public void retriveCacheFromFile(String nomefile, String extAtt, int mode)
		{
			try
			{
				String line = null;
				
				FileReader dat=new FileReader(nomefile+".txt");
				BufferedReader bdat=new BufferedReader(dat);
				FileReader imap=new FileReader(nomefile+".imap");
				BufferedReader bimap=new BufferedReader(imap);
				
				Spql.resultDataset = new ArrayList(0);
				Spql.resultMapItem = new ArrayList(0);
				
				line = bimap.readLine();
				while ((line!=null)&&(line!=""))
				{
					Spql.resultMapItem.add(line.split(" ",2)[1]);  				
					line = bimap.readLine();
				}
				
				line = bdat.readLine();
				while ((line!=null)&&(line!=""))
				{
					Spql.resultDataset.add(line);
					line = bdat.readLine();
				}
				
				bimap.close();
				bdat.close();
				imap.close();
				dat.close();
				
				if (mode==0)
				{
					FileReader amap=new FileReader(nomefile+"_"+extAtt+".amap");
					BufferedReader bamap=new BufferedReader(amap);
					FileReader att=new FileReader(nomefile+"_"+extAtt+".att");
					BufferedReader batt=new BufferedReader(att);
					
					Spql.resultAttribute = new ArrayList(0);
					Spql.resultMapAttribute = new Hashtable(0);
					
					
					line = batt.readLine();
					while ((line!=null)&&(line!=""))
					{
						String token[] = line.split(" ");
						ArrayList list = new ArrayList();
						for (int i=0; i<token.length; i++)
							list.add(token[i]);
						Spql.resultAttribute.add(list);
						line = batt.readLine();
					}
					line = bamap.readLine();
					while ((line!=null)&&(line!=""))
					{
						Spql.resultMapAttribute.put(line.split(" ",2)[0],line.split(" ",2)[1]);  				
						line = bamap.readLine();
					}
					
					
					bamap.close();
					batt.close();
					amap.close();
					att.close();
				}
				
			} catch (Exception ex)  {
				ex.printStackTrace();
			}
			
			
		}
		
		
		public void interrupt()
		{
			interrupt = true;
		}
		
		
		public void run()
		{
			DatasetGenerate();
		}
		
		
		public void DatasetGenerate()
		{
			Gui.jPanel16.repaint();
			Gui.getJTable2(null);
			Spql=null;
			boolean exit = true;
			if ((validquery)||(MiningView))
			{
				try
				{
					Gui.jScrollPane5.setViewportView(Gui.getJTable1(null));
					Gui.jScrollPane6.setViewportView(Gui.getJTable2(null));
					Gui.jScrollPane5.setVisible(true);
					Gui.jScrollPane6.setVisible(true);
					Spql = new SpqlManager(DB_URL,DB_DRIVER,DB_UTENTE,DB_PASSWORD);
					String arg[] = new String[3];
					arg[0] = new String(Gui.jTextPane.getText().trim());
					if (arg[0].contains("ATTRIBUTE")==false)
					{
						if (arg[0].contains("CONSTRAINED BY")==false)
							arg[0]= arg[0]+"\nATTRIBUTE";
						else
							arg[0]= arg[0].substring(0,arg[0].indexOf("\nCONSTRAINED BY"))+"\nATTRIBUTE"+arg[0].substring(arg[0].indexOf("\nCONSTRAINED BY"));
					}
					if (arg[0].contains("CONSTRAINED BY")==false) arg[0]= arg[0]+"\nCONSTRAINED BY";
					
					String order = "\nORDER BY ";
					for (int i=0; i<TransactionTot.size(); i++)
					{
						if (i!=0) order+= ", ";
						order+= TransactionTot.get(i).toString().trim();
					}
					arg[0] = arg[0].split("\nTRANSACTION",2)[0]+order+"\nTRANSACTION"+arg[0].split("\nTRANSACTION",2)[1];
					arg[1] = name;
					arg[2] = attname;
					if (specialmode) Spql.enableSuddivision();
					if (onlyAttribute) Spql.doOnlyAttribute();
					if (resolveAttribute!=null)
					{
						ArrayList r = new ArrayList(0);
						for (int i=0; i<AttributeTot.size();i++)
							if (resolveAttribute.containsKey(AttributeTot.get(i)))
								r.add(resolveAttribute.get(AttributeTot.get(i)));
							else
								r.add(new Integer(0));
						Spql.resolveAttributeMethod(r);
					}
					if (interrupt) return;
					switch (fromCache())
					{
					case 0: retriveCacheFromFile(name,attname,0); break;
					case 1: Spql.doOnlyAttribute(); exit = Spql.execute(arg,false,false,0); retriveCacheFromFile(name,attname,1); break;
					case 2: exit = Spql.execute(arg,false,false,0); break;
					}
				} catch (Exception ex) {exit=false; ex.printStackTrace();}
				if (!exit) {
					Gui.getJDialog5(ErrorMessage.get(5).toString()+"\nQuery Incomplete \n"+Gui.jWarning.getError());
					Gui.jDialog5.setVisible(true);
					working--; return;
				}
				if (da.onlyAttribute) {okresult=true; working--; return;}
				if (interrupt) return;
				ChangeDataset=false;
				Gui.jScrollPane5.setViewportView(Gui.getJTable1(null));
				Gui.jScrollPane6.setViewportView(Gui.getJTable2(null));
				Object[][] Data = new Object[Spql.resultDataset.size()][1];
				if (Spql.resultDataset.size()==0) {working--; return;}
				int maxlen = Spql.resultDataset.get(0).toString().split(" ").length;
				int minlen = Spql.resultDataset.get(0).toString().split(" ").length;
				int avglen = 0;
				for (int i=0; i<Spql.resultDataset.size(); i++)
				{
					if (interrupt) return;
					Data[i][0] = Spql.resultDataset.get(i);
					int len = Data[i][0].toString().split(" ").length;
					if (len>maxlen) maxlen=len;
					if (len<minlen) minlen=len;
					avglen+=len;
					Object token[] = Data[i][0].toString().split(" ");
					Data[i][0] = new String();
					String extra = new String();
					for (int t=0; t<token.length; t++)
					{
						if (token[t].toString().compareTo("")!=0)
						{
							try
							{
								token[t] = Spql.resultMapItem.get(new Integer(token[t].toString()).intValue()).toString().replaceAll(Marker,"");
							} catch (Exception ex)
							{
								continue;
							}
							if (t!=token.length-1) extra = ", "; else extra = "";
							if (ItemTot.size()>1) Data[i][0] = Data[i][0] + token[t].toString()+ extra;
							else Data[i][0] = Data[i][0] + token[t].toString().split(":",2)[1]+ extra;
						}
					}
				}
				avglen=(int) (((float) avglen)/((float)Spql.resultDataset.size())+.5);
				String extra = "";
				int nTransaction = Data.length;
				//				if ((name.compareTo("tmp")==0)&&(limited)) extra =" (PREVIEW)";
				Gui.jLabel18.setText("Number of Transactions: "+nTransaction+"   Maximum lenght: "+maxlen+"   Minimum lenght: "+minlen+"   Average lenght: "+avglen+extra);
				Gui.jScrollPane5.setViewportView(Gui.getJTable1(Data));
				Gui.jScrollPane5.repaint();
				
				if (Spql.resultAttribute.size()>0) {
					Data = new Object[((ArrayList) Spql.resultAttribute.get(0)).size()][Spql.resultAttribute.size()+2];
					for (int i=0; i<((ArrayList) Spql.resultAttribute.get(0)).size(); i++)
					{
						Data[i][0] = (Object) new String(i+"");
						if (ItemTot.size()==1) Data[i][1] =  Spql.resultMapItem.get(i).toString().split(":",2)[1].toString().replaceAll(Marker,"");
						else Data[i][1] =  Spql.resultMapItem.get(i).toString().replaceAll(Marker,"");
					}
					for (int a=0; a<Spql.resultAttribute.size(); a++) 
						for (int i=0; i<((ArrayList) Spql.resultAttribute.get(a)).size(); i++)
						{
							if (Spql.resultMapAttribute.get(((ArrayList) Spql.resultAttribute.get(a)).get(i))!=null)
								Data[i][a+2] = 	Spql.resultMapAttribute.get(((ArrayList) Spql.resultAttribute.get(a)).get(i))+
								" ("+((ArrayList) Spql.resultAttribute.get(a)).get(i)+")";
							else
								Data[i][a+2] = ((ArrayList) Spql.resultAttribute.get(a)).get(i);
						}
					if (interrupt) return;
					Gui.jScrollPane6.setViewportView(Gui.getJTable2(Data));
					Gui.jScrollPane6.repaint();
				} 
				Gui.jSplitPane1.setDividerLocation(Gui.jTabbedPane.getWidth()*5/8);
				if (name.compareTo("tmp")!=0)
				{
					Hashtable info = new Hashtable(0);
					info.put("NAME",name);
					info.put("nTransaction",new Integer(nTransaction));
					info.put("maxL",new Integer(maxlen));
					info.put("minL",new Integer(minlen));
					info.put("avgL",new Integer(avglen));
					ParserXML XML = new ParserXML();
					try {
						XML.XMLWrite(info,name+".desc");
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
				
			}
			else 
				if (validquery==false)
				{
					Gui.jScrollPane5.setVisible(false);
					Gui.jScrollPane6.setVisible(false);
				}
			
			working--;
			okresult=true;
		}
		
	}
	
	
	/**
	 Esegue la discretizzazione di un campo di una tabella secondo i parametri 
	 specificati.
	 */
	public class Discretizator extends Thread
	{
		
		public boolean interrupt=false;
		public Table table=null;
		public int field=-1;
		public ArrayList Interval=null;
		public Hashtable Info=null;
		public int smootingh =-1;
		public String name = "discretized";
		public double[] calc = null;
		
		public void interrupt()
		{
			interrupt = true;
		}
		
		public void run()
		{
			discretize();		
		}
		
		public void discretize()
		{
			if (table==null || field==-1 || Interval==null || Interval.size()==0 || Info==null) {working--; System.out.println("errore"); return;}
			if (interrupt) return;
			progressBarTitle="Discretizing: "+table.Title;
			progressBarMax=0;
			String p0="";
			String p1="";
			if (dbmode.compareTo("MSAccess")==0) {p0="["; p1="]";}
			if (smootingh!=0)
			{
				calc = new double[Interval.size()];
				double[] tot = new double[Interval.size()];
				for (int i=0; i<Interval.size(); i++)
					calc[i] = 0;
				for (int i=0; i<Interval.size(); i++)
					tot[i] = 0;
				Enumeration en = Info.keys();
				while (en.hasMoreElements())
				{
					Object key = en.nextElement();
					double value = Double.valueOf(key.toString()).doubleValue();
					for (int i=0; i<Interval.size(); i++)
					{
						Point2D.Double inter = (Point2D.Double) Interval.get(i);
						if ((value>=inter.x) && (value<inter.y)) 
						{
							switch(smootingh)
							{
							case 1:  calc[i]+=value; tot[i]=tot[i]+1; break;
							case 2:  calc[i]+=Double.valueOf(Info.get(key).toString()).doubleValue(); break;
							}
							break;
						}
					}
				}
				if (smootingh==1)
					for (int i=0; i<Interval.size(); i++)
						calc[i] = calc[i]/tot[i];
			}
			try
			{
				if (smootingh==0) statement.execute("ALTER TABLE "+p0+table.Title+p1+" ADD COLUMN "+name+" Text (20)");
				else statement.execute("ALTER TABLE "+p0+table.Title+p1+" ADD COLUMN "+name+" DOUBLE");
				Enumeration en = Info.keys();
				while (en.hasMoreElements())
				{
					double value = Double.valueOf(en.nextElement().toString()).doubleValue();
					String nvalue = value+"";
					for (int i=0; i<Interval.size(); i++)
					{
						Point2D.Double inter = (Point2D.Double) Interval.get(i);
						if ((value>=inter.x) && (value<inter.y)) 
						{
							switch (smootingh)
							{
							case 0: nvalue=df.format(Double.valueOf(inter.x))+" - "+df.format(Double.valueOf(inter.y)); break;
							default: nvalue=Double.valueOf(calc[i]).toString(); 
							}
							break;
						}
					}
					if (smootingh==0) statement.execute("UPDATE "+p0+table.Title+p1+" SET "+name+" = '"+nvalue+"' WHERE "+table.getModel().getElementAt(field)+" = "+value);
					else statement.execute("UPDATE "+p0+table.Title+p1+" SET "+name+" = "+nvalue+" WHERE "+table.getModel().getElementAt(field)+" = "+value);
				}
				sleep(1000);
			} catch(Exception ex) {ex.printStackTrace();}
			cacheTableInfo.remove(table.Title);
			Gui.jDesktopPane.removeAll();
			selJList=null;
			working++;
			co = new Connecter();
			co.resetCache=false;
			co.connect();
			working--;
		}
		
		
	}
	
	/**
	 Esegue le chiamate di puro SQL al database processando il risultato e 
	 visualizzandolo nello SQL browser.
	 */
	public class Executor extends Thread
	{
		
		public String query = new String();
		public boolean visualize = true;
		public Object[][] Data = null;
		public Object[] Columns = null;
		public javax.swing.text.JTextComponent textComponent = null;
		public String inCacheKey = null;
		public boolean update = true;
		
		public boolean interrupt=false;
		
		public void interrupt()
		{
			interrupt = true;
		}
		
		public void run()
		{
			execSpql();
		}
		
		
		public void execSpql()
		{
			Data = null;
			Columns = null;
			query = query.trim();
			if (query.compareTo("")==0)
			{
				working--;
				return;
			}
			try {
				if (interrupt) return;
				boolean f = statement.execute(query);
				if ((!f)&&(update))
				{
					Gui.jDesktopPane.removeAll();
					selJList=null;
					working++;
					co = new Connecter();
					if (query.toLowerCase().contains("alter")) co.resetCache=true;
					else co.resetCache=false;
					co.start();
					Gui.jDesktopPane.repaint();
					working--;
					return;
				}
				if (!f) 
				{
					working--;
					return;
				}
				if (interrupt) return;
				ResultSet result = statement.getResultSet();
				int numberOfColumns = result.getMetaData().getColumnCount();
				int numberOfRows = 0;
				ArrayList a = new ArrayList();
				while (result.next()) 
				{
					a.add(new ArrayList());
					for (int o=1; o<=numberOfColumns; o++)
						((ArrayList) a.get(numberOfRows)).add(result.getString(o));
					numberOfRows++;
				}
				
				if (interrupt) return;
				Data = new Object[numberOfRows][numberOfColumns];
				for (int i=0; i<numberOfRows;i++)
					Data[i] = ((ArrayList) a.get(i)).toArray();
				
				Columns = new Object[numberOfColumns];
				for (int o=1; o<=numberOfColumns; o++)
					Columns[o-1] = result.getMetaData().getColumnName(o);
				if (textComponent!=null) textComponent.setText(textComponent.getText()+Data[0][0]);
				if (interrupt) return;
				if (visualize)
				{
					Gui.getJDialog6();
					Gui.jScrollPane12.setViewportView(Gui.getJTable4(Data,Columns));
					Gui.jTextPane5.setText(
							"Number of Rows: "+numberOfRows+"\n\n"+	
							"SQL Query: \n"+
							query);
					cSPQL.query = query;
					Gui.jTextPane5.repaint();				
					Gui.jScrollPane12.repaint();
					Gui.jDialog6.setVisible(true);
				}
				working--;
			} catch(Exception ex) 
			{
				if (!visualize)
				{
					Gui.getJDialog5(ex.toString());
				}
				if (visualize)
				{
					if (interrupt) return;
					Gui.getJDialog6();
					Gui.jTextPane5.setText(query);
					cSPQL.query = null;
					Gui.jTextPane5.repaint();
					Gui.jScrollPane12.setViewportView(Gui.getJTable4(null,null));
					Gui.jScrollPane12.repaint();
					Data = new Object [1][1];
					Columns = new Object[1];
					if (ex.getMessage()!=null) Data[0][0] = new String (ex.getMessage());
					else
						if (query.compareTo("")==0) Data[0][0] = new String("ERROR: Syntax error"); 
						else Data[0][0] = new String("ERROR: No connection found");
					Columns[0] = new String ("");
					Gui.jScrollPane12.setViewportView(Gui.getJTable4(Data,Columns));
					Gui.jScrollPane12.repaint();
					Gui.jDialog6.setVisible(true);
				}
				working--; 
			}
			
		}
	}
	
	/**
	Imposta le informazioni del campo correntemente selezionato nel pannello
	Field Information
	 */
	public class InfoVisualizator extends Thread
	{
		
		Table list = null;
		Object field = null;
		
		public void run()
		{
			informationVisual();
		}
		
		public void informationVisual()
		{
			if ((list==null)||(field==null)) return;
			double max = 0;
			double min = 0;
			double avg = 0;
			int distinct=0;
			boolean nr = false;
			if ((cacheTableInfo!=null)&&(cacheTableInfo.containsKey(list.Title)))		
			{
				if ((((TableInfo) (cacheTableInfo.get(list.Title))).Field).containsKey(field))
				{
					max = ((FieldInfo)(((TableInfo) (cacheTableInfo.get(list.Title))).Field).get(field)).max;
					min = ((FieldInfo)(((TableInfo) (cacheTableInfo.get(list.Title))).Field).get(field)).min;
					avg = ((FieldInfo)(((TableInfo) (cacheTableInfo.get(list.Title))).Field).get(field)).avg;
					nr = ((FieldInfo)(((TableInfo) (cacheTableInfo.get(list.Title))).Field).get(field)).nr;
					InfoGraph = ((FieldInfo)(((TableInfo) (cacheTableInfo.get(list.Title))).Field).get(field)).InfoGraph;
					MaxGraph = ((FieldInfo)(((TableInfo) (cacheTableInfo.get(list.Title))).Field).get(field)).MaxGraph;
					distinct = InfoGraph.size(); 
				}
				if (nr) Gui.jTextPane3.setText("Name: "+field+"\n"+"Type: not numeric\nDistincts value: "+distinct+"\n");
				else Gui.jTextPane3.setText("Name: "+field+"\n"+
						"Maximum value: "+df.format(max)+"\n"+
						"Minimum value: "+df.format(min)+"\n"+
						"Avgerage value: "+df.format(avg)+"\n"+
						"Distinct values: "+distinct+"\n"
				);
				Gui.jTextPane3.repaint();
				Gui.jPanel7.repaint();
				Gui.jPanel7.repaint();
			}	
			/*			else
			 if ((ca==null)||(!ca.isAlive()))
			 {
			 ca = new Cacher();
			 working++;
			 ca.start();
			 }*/
		}
	}
	
	/**
	 Ha il compito di materializzare sul DBMS le tabelle riguardanti 
	 il pattern browser e il rule browser e generare i collegamenti 
	 tra di esse.
	 */
	public class Materializer extends Thread
	{
		
		public JTable table=null;
		public int m = 0;
		public String name = null;
		public boolean firstKey = false;
		public String extraFirst = "";
		public boolean interrupt=false;
		public boolean last=true;
		
		public void interrupt()
		{
			interrupt = true;
		}
		
		public void run()
		{
			materializeFromTable();
		}
		
		public void materializeFromTable()
		{
			progressBarTitle="Materializing "+name+"...";
			progressBarMax=table.getModel().getRowCount()+table.getColumnCount()+1;
			progressBarCur=0;
			for (int i=0; i<table.getColumnCount(); i++)
			{
				if (interrupt) return;
				progressBarCur++;
				int extra=0;
				if (i==0) extra = name.length()+1;
				if (table.getColumnName(i).toString().replace(" ","_").length()+extra>m) m =table.getColumnName(i).toString().replace(" ","_").length();
			}
			
			
			String query =	"CREATE TABLE "+name+"\n (";
			for (int i=0; i<table.getColumnCount();i++)
			{
				if (interrupt) break;
				String extra2="";
				if ((i==0)&&(extraFirst!=null)) extra2 = "_"+extraFirst;
				String TypeColumn = "CHAR("+m+")";
				if (table.getModel().getValueAt(0,i).getClass().toString().contains("Integer")) TypeColumn="int";
				if (table.getModel().getValueAt(0,i).getClass().toString().contains("Double")) TypeColumn="float";
				String extra="";
				if ((i==0)&&(firstKey)) extra = " PRIMARY KEY";
				if (i!=table.getColumnCount()-1) query+=table.getColumnName(i).toString().replace(" ","_")+extra2+" "+TypeColumn+extra+",";
				else query+=table.getColumnName(i).toString().replace(" ","_")+extra2+" "+TypeColumn+");\n";
			}
			query = query.replaceAll("\\.","_");
			int a=0;
			int pack = 1000;
			if (dbmode.compareTo("MSAccess")==0)
			{
				if (interrupt) return;
				pack=1;
				exe = new Executor();
				exe.update=false;
				exe.query=query;
				exe.visualize=false;
				working++;
				exe.execSpql();
				query="";
				a=0;
			}
			for (int i=0; i<table.getModel().getRowCount();i++)
			{
				progressBarCur++;
				if (interrupt) break;
				query += "INSERT INTO "+name+" VALUES (";
				for (int o=0; o<table.getModel().getColumnCount();o++)
				{
					String vi = "'";
					if (table.getModel().getValueAt(0,o).getClass().toString().contains("Integer")) vi="";
					if (table.getModel().getValueAt(0,o).getClass().toString().contains("Double")) vi="";
					if (o!=table.getModel().getColumnCount()-1) query +=vi+table.getModel().getValueAt(i,o)+vi+",";
					else query +=vi+table.getModel().getValueAt(i,o)+vi+");\n";
				}
				a++;
				if ((a>=pack)||(i==table.getModel().getRowCount()-1))
				{
					exe = new Executor();
					exe.update=false;
					exe.query=query;
					exe.visualize=false;
					working++;
					exe.execSpql();
					query="";
					a=0;
				}
			}
			if (last)
			{
				working++;
				co = new Connecter();
				co.resetCache=false;
				co.connect();
				working--;
			}
		}
		
	}
	
	/**
	 Esegue le chiamate di SPQL, controllando se in cache esiste gi materiale 
	 che pu essere riutilizzato per evitare computazioni superflue 
	 in caso contrario lancia un worker a sua volta (il Dataset Generator) per 
	 la generazione dei file del dataset, dopo di che costruisce una 
	 chiamata di sistema per il miner e lo fa eseguire facendo 
	 utilizzare i file appena generati.
	 */
	public class Miner extends Thread
	{
		public boolean interrupt=false;
		public String exQuery = null;
		public double autoRules = -1;
		
		public void interrupt()
		{
			interrupt = true;
		}
		
		
		public void run()
		{
			mine();
		}
		
		public void retriveCacheFromFile(String nomefile, String extAtt)
		{
			try
			{
				FileReader imap=new FileReader(nomefile+".imap");
				BufferedReader bimap=new BufferedReader(imap);
				FileReader amap=new FileReader(nomefile+"_"+extAtt+".amap");
				BufferedReader bamap=new BufferedReader(amap);
				FileReader att=new FileReader(nomefile+"_"+extAtt+".att");
				BufferedReader batt=new BufferedReader(att);
				ParserXML XML = new ParserXML();
				
				cSPQL.MapItem = new ArrayList(0);
				cSPQL.Attribute = new ArrayList(0);
				cSPQL.MapAttribute = new Hashtable(0);
				String line = bimap.readLine();
				while ((line!=null)&&(line!=""))
				{
					cSPQL.MapItem.add(line.split(" ",2)[1]);  				
					line = bimap.readLine();
				}
				
				line = batt.readLine();
				while ((line!=null)&&(line!=""))
				{
					String token[] = line.split(" ");
					ArrayList list = new ArrayList();
					for (int i=0; i<token.length; i++)
						list.add(token[i]);
					cSPQL.Attribute.add(list);
					line = batt.readLine();
				}
				line = bamap.readLine();
				while ((line!=null)&&(line!=""))
				{
					cSPQL.MapAttribute.put(line.split(" ",2)[0],line.split(" ",2)[1]);  				
					line = bamap.readLine();
				}
				
				bimap.close();
				bamap.close();
				batt.close();
				imap.close();
				amap.close();
				att.close();
				
				XML.XMLRead(nomefile+".desc");
				cSPQL.NTransacrion=new Integer(((String) XML.getData("nTransaction")).trim()).intValue();
				Gui.jLabel18.setText("Number of Transactions: "+new Integer(((String) XML.getData("nTransaction")).trim())+"   Max lenght: "+new Integer(((String) XML.getData("maxL")).trim())+"   Min lenght: "+new Integer(((String) XML.getData("minL")).trim())+"   Avg lenght: "+new Integer(((String) XML.getData("avgL")).trim()));
			} catch (Exception ex)  {
				ex.printStackTrace();
			}
			
			
		}
		
		
		public void mine()
		{
			if (!validquery) 
			{
				Gui.getJDialog5(ErrorMessage.get(5).toString()+" \n"+Gui.jWarning.getError());
				Gui.jDialog5.setVisible(true);
				working--;
				progressBarTitle=null;
				return;
			}
			progressBarTitle="Setup...";
			progressBarMax=0;
			java.io.File dir = new java.io.File(".\\Dataset\\");
			String[] cacheMine = dir.list();
			int ok = 0;
			int mineok = 0;
			int attok = 0;
			String datasetName = createNameDataset(false);	
			String resultName = createNameResult(false);
			String extAtt = createNameAttribute();
			for (int i=0; i<cacheMine.length; i++)
			{
				if (cacheMine[i].compareTo(resultName+".result")==0) mineok++;
				if (cacheMine[i].compareTo(datasetName+".txt")==0) ok++;
				if (cacheMine[i].compareTo(datasetName+"_"+extAtt+".att")==0) attok++;
				if (cacheMine[i].compareTo(datasetName+".imap")==0) ok++;
				if (cacheMine[i].compareTo(datasetName+"_"+extAtt+".amap")==0) attok++;
				if (cacheMine[i].compareTo(datasetName+".desc")==0) ok++;
			}
			cSPQL = (new Type()).new CurrentSPQLExecution();
			cSPQL.AttributeLabel = new ArrayList(AttributeTot);
			cSPQL.Constraint = new ArrayList(0);
			cSPQL.IndexAttConstrain = new ArrayList(0);
			try
			{
				cSPQL.From = Gui.jTextPane.getText().trim().split("FROM",2)[1].split("\n",2)[0].split(",").length;
			} catch(Exception ex) {cSPQL.From=999;}
			for (int a=0; a<Gui.jList1.getModel().getSize(); a++)
			{
				cSPQL.Constraint.add(Gui.jList1.getModel().getElementAt(a).toString().split(" ",2)[0]);
				try
				{
					cSPQL.IndexAttConstrain.add(new Integer(AttributeTot.indexOf(Gui.jList1.getModel().getElementAt(a).toString().split("@ ",2)[1])));
				} catch (Exception ex) {cSPQL.IndexAttConstrain.add(new Integer(-1));}
			}
			datasetName = createNameDataset(true);
			if (ok!=3) 
			{
				//System.out.println("CREATE DATASET");
				progressBarTitle="Creating Mining View...";		
				working++;
				da = new DatasetGenerator();
				//da.specialmode=true;
				da.name=datasetName;
				da.attname = extAtt;
				da.DatasetGenerate();
				if (da.okresult==false) {working--; Gui.jWindow2.setVisible(false); return;}
				cSPQL.MapAttribute=Spql.resultMapAttribute;
				cSPQL.Attribute=Spql.resultAttribute;
				cSPQL.MapItem=Spql.resultMapItem;
				cSPQL.NTransacrion=Spql.resultDataset.size();
				Spql=null;
			}
			else
			{
				if (attok!=2) 
				{
					progressBarTitle="Creating Attribute...";			
					working++;
					da = new DatasetGenerator();
					da.name=datasetName;
					da.attname = extAtt;
					da.onlyAttribute=true;
					da.DatasetGenerate();
					if (da.okresult==false) {working--; Gui.jWindow2.setVisible(false); return;}
				} 
				progressBarTitle="Retriving cache info...";			
				retriveCacheFromFile(datasetName,extAtt);			
			}
			resultName = createNameResult(true);
			if (mineok!=1)
			{
				//System.out.println("CREATE RESULT");
				Spql=null;
				progressBarTitle="Mining...";
				try
				{
					if (interrupt) return;
					String constraint = buildConstraint();
					String command = "PATTERNIST.exe input "+datasetName+".txt output "+resultName+".result attributes "+datasetName+"_"+extAtt+".att "+constraint;
					pr = new Exec();
					pr.command=command;
					pr.start();
					if (interrupt) return;
					while ((pr!=null)&&(pr.isAlive())) {}
					if (interrupt) return;
				} catch(Exception ex) {ex.printStackTrace();}
			}
			else
			{
				progressBarTitle="Retriving cache info...";			
				//System.out.println("CACHED RESULT");
			}
			cSPQL.NameResult = createNameResult(true);
			if (interrupt) return;
			readResult(resultName+".result");
			working--;
			if (interrupt) return;
			Gui.jWindow2.setVisible(false);
			if (autoRules!=-1) 
			{
				if (Gui.jDialog11!=null) Gui.jDialog11.setVisible(false);
				generateRules(autoRules);
			}
			if (exQuery!=null)
			{
				Gui.jTextPane.setText(exQuery);
				ChangeDataset=true;
			}
			
			parser();
		}	
	}
	
	/**
	 Permette la coerenza dei dati durante il sort mantenendo il link tra
	 oggetto da ordinare e riga della tabella orignale
	 */
	public class DataSorter implements Comparable
	{
		public DataSorter(Comparable o, int id)
		{
			item=o;
			index=id;
		}
		Object item;
		int index;
		
		public int compareTo(Object arg0) {
			return (((Comparable) item).compareTo(((DataSorter) arg0).item));
		}
	}
	
	
	/**
	 * Genera il nome del file del Dataset
	 * @param suffix se true il nome viene generato con il path completo
	 */
	public String createNameDataset(boolean suffix)
	{
		String code=new String();
		for (int a=0; a<Gui.jListTransactionBasket.getModel().getSize(); a++)
			code+=Gui.jListTransactionBasket.getModel().getElementAt(a);
		for (int a=0; a<Gui.jListItemBasket.getModel().getSize(); a++)
			code+=Gui.jListItemBasket.getModel().getElementAt(a);
		try
		{
			code+=Gui.jTextPane.getText().substring(Gui.jTextPane.getText().indexOf("WHERE"),Gui.jTextPane.getText().indexOf("\nTRANSACTION"));
		} 
		catch (Exception ex) {}
		String datasetName = "Dataset"+code.trim().hashCode();
		if (suffix) return "Dataset\\"+datasetName;
		else return datasetName;
	}
	
	/**
	 * Genera il nome del file degli Attributi
	 */
	public String createNameAttribute()
	{
		String code=new String();
		for (int a=0; a<Gui.jListAttributeBasket.getModel().getSize(); a++)
			code+=Gui.jListAttributeBasket.getModel().getElementAt(a);
		code+=resolveAttribute.toString();
		return (code.hashCode()+"");
	}
	
	
	/**
	 * Genera il nome del file del file dei Risultati
	 * @param suffix se true il nome viene generato con il path completo
	 */
	public String createNameResult(boolean suffix)
	{
		String code=new String();
		for (int a=0; a<Gui.jListTransactionBasket.getModel().getSize(); a++)
			code+=Gui.jListTransactionBasket.getModel().getElementAt(a);
		for (int a=0; a<Gui.jListItemBasket.getModel().getSize(); a++)
			code+=Gui.jListItemBasket.getModel().getElementAt(a);
		for (int a=0; a<Gui.jListAttributeBasket.getModel().getSize(); a++)
			code+=Gui.jListAttributeBasket.getModel().getElementAt(a);
		String resultName = "Result"+(code.trim()+resolveAttribute.toString()+(Gui.jTextPane.getText())).hashCode();
		if (suffix) return "Dataset\\"+resultName;
		else return resultName;
	}
	
	/**
	 * Genera il nome del file dei Metadati
	 */
	public String createNameCache()
	{
		String code=new String();
		code = DB_URL+DB_DRIVER;
		String resultName="CacheInfo"+code.hashCode()+".desc";
		return "TableInfo\\"+resultName;
	}
	
	
	
	
	/**
	 determina se ci sono Attributi con possibili conflitti
	 */
	public void findConflict()
	{
		ArrayList UnivocTot = new ArrayList(0);
		for (int i=0; i<jList.size(); i++)
			for (int o=0; o<((Table)jList.get(i)).UnivocKey.size(); o++)
				UnivocTot.add(((Table)jList.get(i)).Title+"."+((Table)jList.get(i)).UnivocKey.get(o));
		
		for (int i=0; i<jList.size(); i++)
		{
			boolean allUnivoc=true;
			int ok = 0;
			int notUnivocNotPrimary=0;
			for (int o=0; o<((Table)jList.get(i)).Item.size(); o++)
			{
				String name =  ((Table)jList.get(i)).Title+"."+((Table)jList.get(i)).Item.get(o);
				if ( (!UnivocTot.contains(name)) && 
						(!((Table)jList.get(i)).PrimaryKey.contains(((Table)jList.get(i)).Item.get(o))) ) notUnivocNotPrimary++;
				if (!UnivocTot.contains(name)) allUnivoc=false; 
				if (((Table)jList.get(i)).PrimaryKey.contains(((Table)jList.get(i)).Item.get(o))) ok++;
			}
			if (allUnivoc) ((Table)jList.get(i)).conflict=false; 
			else if ((ok==((Table)jList.get(i)).PrimaryKey.size())&&(notUnivocNotPrimary==0)) ((Table)jList.get(i)).conflict=false; 
			else ((Table)jList.get(i)).conflict=true;
		}
		
	}
	
	
	
	
	
	/**
	 Genera la stringa di Constraint per il lancio di Patternist 
	 */
	public String buildConstraint()
	{
		String ret = new String();
		for (int i=0; i<Gui.jList1.getModel().getSize(); i++)
		{
			String tmp = Gui.jList1.getModel().getElementAt(i).toString();
			String token[] = new String[6]; 
			token = tmp.split(" ");
			String extra = "";
			int attributeid = -1;
			if (token[1].startsWith("{"))
			{
				if (tmp.contains("@"))
				{
					String[] token2 = tmp.split(" @ ",2);
					extra = AttributeTot.indexOf(token2[1])+",";
					attributeid = AttributeTot.indexOf(token2[1]);
					tmp = token2[0];
					tmp = tmp.replaceAll("\\}","");
					token = tmp.split("\\{",2);
					token=token[1].split(", ");
					ret += ((String) constraint.get(tmp.split(" ",2)[0])) + " ["+extra;
					for (int o=0; o<token.length;o++)
					{
						Enumeration en = cSPQL.MapAttribute.keys();
						while (en.hasMoreElements())
						{
							String element = en.nextElement().toString();
							if (cSPQL.MapAttribute.get(element).toString().compareTo(token[o].trim())==0)
								ret+= element+",";
						}
					}
					ret = ret.substring(0,ret.length()-1);
					ret += "]";
				}
				else
				{
					tmp = tmp.replaceAll("\\}","");
					token = tmp.split("\\{",2);
					token=token[1].split(", ");
					ret += ((String) constraint.get(tmp.split(" ",2)[0])) + " ["+extra;
					for (int o=0; o<token.length;o++)
					{
						for (int a=0; a<cSPQL.MapItem.size();a++)
						{
							if (cSPQL.MapItem.get(a).toString().compareTo(token[o].trim())==0)
								ret+= i+",";
						}
					}
					ret = ret.substring(0,ret.length()-1);
					ret += "]";
				}
			}
			else
			{
				if (token.length==5) ret += ((String) constraint.get((token[0]+" "+token[1]))) + " [" + (AttributeTot.indexOf(token[4])) + ","+ token[2] + "] ";
				else ret += ((String) constraint.get((token[0]+" "+token[1]))) + " [" + token[2] + "] ";
			}
		}
		try
		{
			int s = new Integer(Gui.jTextField4.getText()).intValue();
			ret = "sigma "+s+" " +ret;
		}
		catch (Exception ex)
		{
			try
			{
				double s = new Double(Gui.jTextField4.getText().replace("%","")).doubleValue();
				int sint = (int) (cSPQL.NTransacrion*s/100);
				ret = "sigma "+sint+" " +ret;
			} catch (Exception ex2) 
			{
				ret = "sigma 1 " + ret;
			}
		}			
		return ret;
	}
	
	
	public int getIndex(Table t, String name) 
	{
		if (t.rollup) return 0;
		for (int i=0; i<t.getModel().getSize(); i++)
			if (((String) (t.getModel().getElementAt(i))).compareTo(name)==0) return i;
		return -1;
	}
	
	public Table getTable(String name) 
	{
		for (int i=0; i<jList.size(); i++) 
			if (((String) ((Table) jList.get(i)).Title).compareTo(name)==0) return ((Table) jList.get(i));
		return null;
	}
	
	
	/**
	 * Il parser SPQL che gestisce la coerenza tra query SPQL e dati visuali
	 */
	public void parser()
	{
		Gui.jWarning.setWarning(6,false);
		//Gui.jWarning.setWarning(0,false);
		Gui.jWarning.setWarning(5,false);
		SpqlManager temp = new SpqlManager();
		String text = Gui.jTextPane.getText();
		Object Data[] = new Object[0];
		Gui.jList1.setListData(Data);
		validquery=true;
		validdataset=true;
		
		if (text.compareTo("")==0)
		{
			ChangeDataset=true;
			Object data[] = new Object[0]; 
			Gui.jList1.setListData(data);
			for (int i=0; i<jList.size(); i++)
			{
				((Table) jList.get(i)).Attribute.clear();
				((Table) jList.get(i)).Item.clear();
				((Table) jList.get(i)).Transaction.clear();
				resolveAttribute.clear();
			}
			Gui.jTextField4.setText("?");
			inverseParser();
			Gui.jDesktopPane.repaint();
			return;
		}
		
		boolean noattribute=false;
		boolean noconstraint=false;
		if (text.contains("ATTRIBUTE")==false)
		{
			text= text+"\nATTRIBUTE";
			noattribute=true;
		}
		if (text.contains("CONSTRAINED BY")==false)
		{
			text= text+"\nCONSTRAINED BY";
			noconstraint=true;
		}
		text = text.trim();
		String[] ris = temp.takeSqlE(text);
		if (ris==null) {
			for (int i=0; i<jList.size(); i++)
			{
				Table current = (Table) jList.get(i);
				if (!text.contains("TRANSACTION")) {current.Transaction.clear(); TransactionTot.clear();}
				if (!text.contains("ITEM")) {current.Item.clear(); ItemTot.clear();}
				if (noattribute) {current.Attribute.clear(); AttributeTot.clear();}
			}
			Object[] datavuota=new Object[0];
			if (noconstraint) Gui.jList1.setListData(datavuota);
			//if (Gui.jTextPane.getText().compareTo("")!=0) Gui.jWarning.setWarning(0,true);
			validquery=false; 
			validdataset=false;
			Gui.jList1.repaint();
			Gui.jListTransactionBasket.setListData(TransactionTot.toArray());
			Gui.jListItemBasket.setListData(ItemTot.toArray());
			Gui.jListAttributeBasket.setListData(AttributeTot.toArray());
			Gui.jDesktopPane.repaint();
			return;
		}
		ArrayList ExtTransaction = new ArrayList(0);
		ArrayList ExtItem = new ArrayList(0);
		ArrayList ExtAttribute = new ArrayList(0);
		ArrayList ExtSelect = new ArrayList(0);
		Gui.jTextField4.setText(ris[5]);
		
		ExtTransaction = temp.extCampi(ris[1]);
		ExtItem = temp.extCampi(ris[2]);
		ExtAttribute = temp.extCampi(ris[3]);
		ExtSelect = temp.setRename(temp.extCampi(ris[4]));
		validquery=true;
		boolean ok=true;
		if (!temp.validation(ExtTransaction, ExtSelect)) {ok=false;}
		if (!temp.validation(ExtItem, ExtSelect)) {ok=false;}
		if (!temp.validation(ExtAttribute, ExtSelect)) {ok=false;}
		if (!ok) 
		{
			validquery=false;
			validdataset=false;
			Gui.jWarning.setWarning(5,true);
		}
		for (int i=0; i<jList.size(); i++)
		{
			Table current = (Table) jList.get(i);
			current.Transaction.clear();
			current.Attribute.clear();
			current.Item.clear();
			for (int a=0; a<current.getModel().getSize(); a++)
			{
				String value = current.Title+"."+current.getModel().getElementAt(a);
				if (ExtSelect.indexOf(value)!=-1)
				{
					Integer n = new Integer(ExtSelect.indexOf(value)+1);
					if ((ExtTransaction.indexOf(n)!=-1)&&(!current.Transaction.contains(current.getModel().getElementAt(a)))) current.Transaction.add(current.getModel().getElementAt(a));
					if ((ExtItem.indexOf(n)!=-1)&&(!current.Item.contains(current.getModel().getElementAt(a)))) current.Item.add(current.getModel().getElementAt(a));
					if ((ExtAttribute.indexOf(n)!=-1)&&(!current.Attribute.contains(current.getModel().getElementAt(a)))) current.Attribute.add(current.getModel().getElementAt(a));
				}
			}
		}
		TransactionTot.clear();
		ItemTot.clear();
		AttributeTot.clear();
		Select.clear();
		for (int i=0; i<jList.size(); i++)
		{
			Table current = (Table) jList.get(i);
			for (int a=0; a<current.Transaction.size(); a++)
			{
				if (Select.contains(current.Transaction.get(a))==false) Select.add(current.Title+"."+current.Transaction.get(a));
				if (TransactionTot.contains(current.Transaction.get(a))==false) TransactionTot.add(current.Title+"."+current.Transaction.get(a));
			}
			for (int a=0; a<current.Item.size(); a++)
			{
				if (Select.contains(current.Item.get(a))==false) Select.add(current.Title+"."+current.Item.get(a));
				if (ItemTot.contains(current.Item.get(a))==false) ItemTot.add(current.Title+"."+current.Item.get(a));
			}
			for (int a=0; a<current.Attribute.size(); a++)
			{
				if (Select.contains(current.Attribute.get(a))==false) Select.add(current.Title+"."+current.Attribute.get(a));
				if (AttributeTot.contains(current.Attribute.get(a))==false) AttributeTot.add(current.Title+"."+current.Attribute.get(a));
			}
		}
		Gui.jListTransactionBasket.setListData(TransactionTot.toArray());
		Gui.jListItemBasket.setListData(ItemTot.toArray());
		Gui.jListAttributeBasket.setListData(AttributeTot.toArray());
		String c= text.subSequence(text.indexOf("CONSTRAINED BY")+14,text.length()).toString();
		c = c.trim();
		String[] constraint = c.split("AND");
		ArrayList listc = new ArrayList(0);
		int a = 0;
		for (int i=0; i<constraint.length; i++)
			if ((constraint[i].compareTo("")!=0&&constraint[i].compareTo(" ")!=0))
			{
				constraint[i] = constraint[i].trim();
				try
				{
					constraint[i] = constraint[i].trim();
					if ((constraint[i].startsWith("Lenght"))||(constraint[i].startsWith("Superset"))||(constraint[i].startsWith("Subset"))||(constraint[i].startsWith("Attribute")))
					{
						if (constraint[i].startsWith("Attribute"))
						{
							String token[] = constraint[i].split("\\(",2);
							String attribute = token[1].split(",",2)[0];
							constraint[i] = constraint[i].replace(attribute+",","");
							constraint[i] = constraint[i].replaceFirst("\\("," ");
							constraint[i] = constraint[i].replaceFirst("\\)"," ");
							constraint[i] +="@ "+attribute;
							listc.add(constraint[i].trim());
						}
						if (constraint[i].startsWith("Lenght"))
						{
							String token[] = constraint[i].split("=",2);
							Integer test = new Integer(token[1]);
							constraint[i]=constraint[i].replaceAll(">="," >= ");
							constraint[i]=constraint[i].replaceAll("<="," <= ");
							listc.add(constraint[i]);
						}
						if ((constraint[i].startsWith("SuperSet"))||(constraint[i].startsWith("SubSet")))
						{
							constraint[i] = constraint[i].replaceFirst("\\("," ");
							constraint[i] = constraint[i].replaceFirst("\\)"," ");
							listc.add(constraint[i].trim());
						}
					}
					else
					{
						String token[] = new String[5];
						token[0] = constraint[i].split("\\(",2)[0];
						token[1] = constraint[i].split("\\)",2)[1].split("=",2)[0]+"=";
						token[2] = constraint[i].split("\\)",2)[1].split("=",2)[1];
						token[3] = "@";
						token[4] = constraint[i].split("\\(",2)[1].split("\\)",2)[0];
						Integer test = new Integer(token[2]);
						if (AttributeTot.contains(token[4]))
						{
							listc.add (token[0]+" "+token[1]+" "+token[2]+" "+token[3]+" "+token[4]);
							a++;
						}
					}
				} catch (Exception ex) {ex.printStackTrace();}
			}
		Data = new Object[listc.size()];
		for (int i=0; i<listc.size(); i++)
			Data[i] = listc.get(i);
		Gui.jList1.setListData(Data);
		Gui.jList1.repaint();
		Gui.jDesktopPane.repaint();
	}
	
	/**
	 * L'Inverse Parser che gestisce la coerenza tra dati visuali e SPQL
	 */
	public void inverseParser()
	{
		Gui.jWarning.setWarning(6,false);
		//Gui.jWarning.setWarning(0,false);
		Gui.jWarning.setWarning(1,false);	
		Gui.jWarning.setWarning(4,false);	
		From = new ArrayList();
		AttributeTot.clear();
		TransactionTot.clear();
		Select.clear();
		ItemTot.clear();
		for (int i=0; i<jList.size(); i++)
		{
			Table current = (Table) jList.get(i);
			for (int a=0; a<current.Transaction.size(); a++)
			{
				if (Select.contains(current.Transaction.get(a))==false) Select.add(current.Title+"."+current.Transaction.get(a));
				if (TransactionTot.contains(current.Transaction.get(a))==false) TransactionTot.add(current.Title+"."+current.Transaction.get(a));
				if (From.contains(current.Title)==false) From.add(current.Title);
			}
			for (int a=0; a<current.Item.size(); a++)
			{
				if (Select.contains(current.Item.get(a))==false) Select.add(current.Title+"."+current.Item.get(a));
				if (ItemTot.contains(current.Item.get(a))==false) ItemTot.add(current.Title+"."+current.Item.get(a));
				if (From.contains(current.Title)==false) From.add(current.Title);
			}
			for (int a=0; a<current.Attribute.size(); a++)
			{
				if (Select.contains(current.Attribute.get(a))==false) Select.add(current.Title+"."+current.Attribute.get(a));
				if (AttributeTot.contains(current.Attribute.get(a))==false) AttributeTot.add(current.Title+"."+current.Attribute.get(a));
				if (From.contains(current.Title)==false) From.add(current.Title);
			}
		}
		validquery=true;
		validdataset=true;
		String sigma="";
		try	{if (new Integer(Gui.jTextField4.getText()).intValue()>=0) sigma = new Integer(Gui.jTextField4.getText()).toString();} 
		catch (Exception ex) {
			try {
				sigma = new Double(Gui.jTextField4.getText().replaceFirst("%","")).toString()+"%";
			}catch (Exception ex2) {}
		}
		if (sigma.compareTo("")==0)	
		{
			if (Gui.jTextPane.getText().compareTo("")!=0) Gui.jWarning.setWarning(4,true);	
			validquery=false; 
			sigma="?";
		}
		String t = new String("");
		if (Select.size()!=0) t =	"MINE PATTERNS WITH SUPP>= "+sigma+" IN\nSELECT ";
		for (int i=0; i<Select.size(); i++)
		{
			if (i!=0) t+= ", ";
			t+=Select.get(i).toString().trim();
		}
		if (From.size()!=0) t+= 	"\nFROM ";
		for (int i=0; i<From.size(); i++)
		{
			if (i!=0) t+= ", ";
			if (dbmode.compareTo("MSAccess")==0) t+= "["+From.get(i).toString().trim()+ "]";
			else t+= From.get(i).toString().trim();
		}
		
		if (TransactionTot.size()!=0) t+= "\n"+ generateWhere(From);
		
		if (TransactionTot.size()!=0) t+=	"TRANSACTION ";
		for (int i=0; i<TransactionTot.size(); i++)
		{
			if (i!=0) t+= ", ";
			t+= TransactionTot.get(i).toString().trim();
		}
		
		if (ItemTot.size()!=0) t+=	"\nITEM ";
		for (int i=0; i<ItemTot.size(); i++)
		{
			if (i!=0) t+= ", ";
			t+= ItemTot.get(i).toString().trim();
		}
		if (AttributeTot.size()!=0) t+=		"\nATTRIBUTE ";
		for (int i=0; i<AttributeTot.size(); i++)
		{
			if (i!=0) t+= ", ";
			t+= AttributeTot.get(i).toString().trim();
		}
		if (Gui.jList1.getModel().getSize()!=0) t+= "\nCONSTRAINED BY ";
		for (int i=0; i<Gui.jList1.getModel().getSize(); i++)
		{
			String tmp = Gui.jList1.getModel().getElementAt(i).toString();
			String token[] = new String[6]; 
			token = tmp.split(" ");
			if (i>0) t+=" AND ";
			if (token[1].startsWith("{"))
			{
				token = tmp.split(" ",2);
				if (token[1].contains("@"))
				{
					String[] token2 = token[1].split(" @ ",2); 
					t+= token[0]+"("+token2[1]+","+token2[0]+")";
				}
				else
					t+= token[0]+"("+token[1]+")";
				
			}
			else
			{
				if (token.length==5) t+= token[0]+"("+token[4]+")"+token[1]+token[2]+" ";
				else t+= "Lenght"+token[1]+token[2]+" ";
			}
		}
		t = t.trim();
		if ((TransactionTot.size()==0)||(ItemTot.size()==0)) 
		{
			//if (Gui.jTextPane.getText().compareTo("")!=0) Gui.jWarning.setWarning(0,true);
			validquery=false;
			validdataset=false;
		} 
		if (searchConnection(From,null)==false) 
		{
			Gui.jWarning.setWarning(1,true);
			validquery=false;
			validdataset=false;
		}
		Gui.jListTransactionBasket.setListData(TransactionTot.toArray());
		Gui.jListItemBasket.setListData(ItemTot.toArray());
		Gui.jListAttributeBasket.setListData(AttributeTot.toArray());
		Gui.jTextPane.setText(t);
		Gui.jTabbedPane1.repaint();
		Gui.jTextPane.repaint();
		if (AUTOUPDATE)
		{
			working++;
			da = new DatasetGenerator();
			da.name="tmp";
			da.start();
		}
	}
	
	/** Genera il WHERE necessario durante la costruzione della query SPQL basandosi sulle
	 * lista di tabelle da collegare
	 * @param table La lista di tabelle utilizzate al momento per gli id
	 * @return
	 */
	public String generateWhere(ArrayList table)
	{
		ArrayList remain = new ArrayList(0);
		if (searchConnection(table,null)==false) return "";
		if (table.size()<2) return "";
		remain.add(getTable((String)table.get(0)));
		String w = new String("");
		for (int i=0; i<jList.size(); i++)
		{
			ArrayList Disabled = new ArrayList(0);
			Disabled.add(((Table) jList.get(i)).Title);
			if (searchConnection(table,Disabled)==false) remain.add(jList.get(i)); 
		}
		for (int i=0; i<remain.size(); i++)
		{
			for (int o=0; o<((Table) remain.get(i)).ForeignTable.size(); o++)
				if (remain.contains(getTable((String)((Table) remain.get(i)).ForeignTable.get(o))))
				{
					if (w.compareTo("")!=0) w = w + " AND "; else w="WHERE ";
					w = w + ((Table) remain.get(i)).Title+"."+((Table) remain.get(i)).ForeignKey.get(o) +"="+ ((Table) remain.get(i)).ForeignTable.get(o)+"."+((Table) remain.get(i)).ForeignPrimary.get(o);
				}
		}
		return (w+" \n");
	}
	
	public ArrayList getConnectedTable(String title, ArrayList Disabled)
	{
		ArrayList s = new ArrayList(0);
		for (int i=0; i<jList.size(); i++)
			if ((((Table) jList.get(i)).ForeignTable.contains(title))
					&&(Disabled.contains(((Table) jList.get(i)).Title)==false))
				s.add(((Table)jList.get(i)).Title);
		return s;
	}
	
	/**
	 * Esegue una ricerca a ventaglio per determinare se esiste una connessione 
	 * tra le varie tabelle con campi selezionati come id
	 * 
	 * @param tables le tabelle con campi selezionati
	 * @param Disabled le tabelle da non considerare come "valide" all'interno della ricerca
	 * @return se esiste una connessione
	 */
	public boolean searchConnection(ArrayList tables, ArrayList Disabled)
	{
		if (tables.size()==0) return true;
		if (Disabled==null) Disabled = new ArrayList(0); 
		boolean done=false;
		ArrayList border = new ArrayList(0);
		ArrayList newborder = new ArrayList(0);
		ArrayList visited = new ArrayList(0);
		visited.add((String)tables.get(0));
		border.add(getTable((String)tables.get(0)));
		do
		{
			newborder.clear();
			for (int i=0; i<border.size(); i++)
			{
				for (int o=0; o<((Table)border.get(i)).ForeignTable.size(); o++ )
					if  ( (visited.contains((String)((Table)border.get(i)).ForeignTable.get(o))==false)
							&&(Disabled.contains((String)((Table)border.get(i)).ForeignTable.get(o))==false))
					{
						newborder.add(getTable((String)((Table)border.get(i)).ForeignTable.get(o)));
						visited.add((String)((Table)border.get(i)).ForeignTable.get(o));
					}
				ArrayList s = getConnectedTable(((Table)border.get(i)).Title,Disabled);
				for (int o=0; o<s.size(); o++ )
					if  (visited.contains((String)s.get(o))==false)
					{
						newborder.add(getTable((String)s.get(o)));
						visited.add((String) s.get(o));
					}
			}
			if (newborder.size()==0) done=true; else border = new ArrayList(newborder);
		} while (done==false);
		if (visited.containsAll(tables)) return true; else return false;
	}
	
	public java.awt.geom.Line2D.Double getLine(Table t, int id_key, Table t2, int id_key2)
	{
		java.awt.geom.Line2D.Double l = new java.awt.geom.Line2D.Double();
		double h = t.getFontMetrics(t.getFont()).getHeight();
		if (t2.getX()>=t.getX()+t.getWidth()/2)
		{
			l.x1 = t.getX()+t.getWidth();
			l.y1 = t.getY()+h*id_key+h/2;
			l.x2 = t2.getX();
			l.y2 = t2.getY()+h*id_key2+h/2;
		}
		else
		{
			l.x1 = t.getX();
			l.y1 = t.getY()+h*id_key+h/2;
			l.x2 = t2.getX()+t2.getWidth();
			l.y2 = t2.getY()+h*id_key2+h/2;
		}
		return l;
	}
	
	
	
	
	
	/**
	 Genera una nuova tabella e la aggiunge al Workbench, aggiungedo ad essa tutti i
	 gestori di eventi.
	 */
	public JList createJList() {
		jList.add((new Type()).new Table());
		((JList) jList.get(jList.size()-1)).setBounds(new java.awt.Rectangle(30,30,10,20));
		((JList) jList.get(jList.size()-1)).setBorder(new javax.swing.border.LineBorder(java.awt.Color.gray));
		((JList) jList.get(jList.size()-1)).addKeyListener(new java.awt.event.KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				if (e.getKeyChar()==KeyEvent.VK_DELETE)
				{
					if (selJList==null) return;
					Table tmp = selJList;
					tmp.setVisible(false);
					if (jListProperty.containsKey(tmp.Title)) ((Property) jListProperty.get(tmp.Title)).visible=false;
					Gui.jDesktopPane.repaint();
				}
			}
		});
		
		((JList) jList.get(jList.size()-1)).addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
			public void mouseDragged(MouseEvent e) {
				if (Drag)
				{
					Table tmp = (Table) e.getSource();
					tmp.setLocation(tmp.getX()+e.getX()-dragPoint.x,tmp.getY()+e.getY()-dragPoint.y);
					if (jListProperty.containsKey(tmp.Title)) ((Property) jListProperty.get(tmp.Title)).location = tmp.getLocation();
					Gui.jDesktopPane.repaint();
				}
			}
		});
		((JList) jList.get(jList.size()-1)).setCellRenderer(Gui.new TableEntry());
		((JList) jList.get(jList.size()-1)).addMouseListener(new java.awt.event.MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				Table tmp = ((Table)e.getSource());
				int id = tmp.locationToIndex(e.getPoint());
				if (id!=0) return;
				if ((e.getButton()==MouseEvent.BUTTON1)&&(e.getClickCount()>=2))
				{
					if (tmp.rollup==true) maximizeTable(tmp); 
					else
						if (tmp.rollup==false) minimizeTable(tmp);
					Gui.jDesktopPane.repaint();
				}
			}
			public void mousePressed(MouseEvent e) {
				if (e.getButton()==MouseEvent.BUTTON1) {Drag=true; dragPoint = e.getPoint();}else Drag=false;
				if (Gui.jWindow1!=null) Gui.jWindow1.setVisible(false);
				if (Gui.jWindow4!=null) Gui.jWindow4.setVisible(false);
			}
			public void mouseReleased(MouseEvent  e) {
				Table tmp = ((Table)e.getSource());
				int id = tmp.locationToIndex(e.getPoint());
				if (id!=0) tmp.setSelectedIndex(id);
				boolean changeSel=false;
				if ((selJList==null)||(selJList.equals(tmp)==false))
				{
					if (selJList!=null) 
					{ 
						selJList.setBorder(new javax.swing.border.LineBorder(Color.GRAY));
						selJList.setSelectedIndex(0);
					}
					tmp.setBorder(new javax.swing.border.LineBorder(java.awt.Color.BLACK));
					if ((tab!=null)&&(tab.isAlive())) {tab.interrupt(); working--;}
					if ((exe!=null)&&(exe.isAlive())) {exe.interrupt(); working--;}
					selJList = tmp;
					ChangeTable=true;
					working++;
					tab = new TableVisualizator();
					tab.start();
					changeSel=true;
					ChangeGraph=true;
				} 
				if (id==0)
				{
					InfoGraph=null;
					selJListField=-1;
					ChangeGraph=true;
					Gui.jTextPane3.setText("");
					Gui.jPanel7.repaint();
					if (e.getButton()==MouseEvent.BUTTON3)
					{
						boolean pop[] = new boolean[1];
						pop[0]=true;
						Gui.getJWindow4(pop);
						e.translatePoint(Gui.jSplitPane2.getDividerLocation()+tmp.getX(),tmp.getY()+Gui.jJMenuBar.getHeight());
						Gui.jWindow4.setLocation(e.getX(),e.getY());
						Gui.jWindow4.setVisible(true);
					}
					Gui.jDesktopPane.repaint();
					return;
				}
				if (((selJListField!=tmp.getSelectedIndex())||(changeSel))&&(id!=0))
				{
					if ((inf!=null)&&(inf.isAlive())) 
					{
						inf.interrupt(); 
					}
					inf = new InfoVisualizator();
					inf.list = tmp;
					inf.field = tmp.getSelectedValue();
					inf.start();
					selJListField=tmp.getSelectedIndex();
					ChangeGraph=true;
					if (Gui.jMenuItem3!=null) Gui.jMenuItem3.setEnabled(false);					
					if (((cacheTableInfo!=null)&&(cacheTableInfo.containsKey(selJList.Title))) &&		
							((((TableInfo) (cacheTableInfo.get(selJList.Title))).Field).containsKey(selJList.getModel().getElementAt(selJListField))))
						if (Gui.jMenuItem3!=null)
							if ((((FieldInfo)(((TableInfo) (cacheTableInfo.get(selJList.Title))).Field).get(selJList.getModel().getElementAt(selJListField))).nr)==false) Gui.jMenuItem3.setEnabled(true); 
				}
				if (e.getButton()==MouseEvent.BUTTON3)
				{
					boolean pop[] = new boolean[6];
					for (int i=0; i<6; i++) pop[i]=false;
					
					for (int i=0; i<jList.size(); i++)
						if (tmp.equals(jList.get(i))) idtable = i;
					if (TransactionTot.size()==0) 
					{
						pop[0]=true;
					} 
					else
					{
						pop[0]=true;
						pop[1]=true;
						pop[2]=true;
						if ( (AttributeTot.contains(tmp.Title+"."+(String) tmp.getSelectedValue()))||
								(TransactionTot.contains(tmp.Title+"."+(String) tmp.getSelectedValue()))||
								(ItemTot.contains(tmp.Title+"."+(String) tmp.getSelectedValue())) ) pop[3]=true;
						if (AttributeTot.contains(tmp.Title+"."+(String) tmp.getSelectedValue())) pop[4]=true;
						if ((AttributeTot.contains(tmp.Title+"."+(String) tmp.getSelectedValue()))&&(tmp.conflict)) pop[5]=true;							
					}
					
					Gui.getJWindow1(pop);
					e.translatePoint(Gui.jSplitPane2.getDividerLocation()+tmp.getX(),tmp.getY()+Gui.jJMenuBar.getHeight());
					Gui.jWindow1.setLocation(e.getX(),e.getY());
					Gui.jWindow1.setVisible(true);
				}
				else 
					if ((Gui.jWindow1!=null)&&(Gui.jWindow1.isVisible())) Gui.jWindow1.setVisible(false);
				Gui.jDesktopPane.repaint(); 
			} 
			
		});	
		return ((JList) jList.get(jList.size()-1));
	}
	
	/**
	 * Legge e esegue il remapping dei risultati ottenuti dal processo di mining
	 * @param nomefile il nome del file del dataset
	 */
	public void readResult(String nomefile)
	{
		BufferedReader br=null;
		FileReader r=null;
		ArrayList result = new ArrayList(0);
		try {
			r=new FileReader(nomefile);
			br=new BufferedReader(r);
		} catch(Exception e) {}
		String c="";
		try {
			do {
				c=br.readLine();
				if (c!=null) result.add(c);
			} while (c!=null);
			r.close();
		} catch(Exception e) {}
		
		int maxlen= 0;
		int minlen= 0;
		int avglen=0;
		if (result.size()>0)
		{
			maxlen=((result.get(0).toString()).split(" ")).length-1;
			minlen=((result.get(0).toString()).split(" ")).length-1;
			for (int i =0; i<result.size(); i++)
			{
				int len = ((result.get(i).toString()).split(" ")).length-1;
				if (len>maxlen) maxlen=len;
				if (len<maxlen) minlen=len;
				avglen+=len;
			}
		} 
		cSPQL.Result = result;
		avglen = (int) (((float) (avglen)/((float) result.size()))+.5);
		Gui.getJDialog8();
		String text =
			"Number of Patterns: "+result.size()+	"\n"+		
			"Maximum lenght: "+maxlen+"\n"+
			"Minimum lenght: "+minlen+"\n"+
			"Average lenght: "+avglen+"\n\n"+
			"SPQL Query: \n" +
			Gui.jTextPane.getText();
		Gui.jTextPane6.setText(text);
		Gui.jTextPane6.repaint();
		Gui.jDialog8.setVisible(true);
		Gui.jMenuItem1.setText(ItemView);
		Gui.jDialog8.setVisible(false);
		visualBrowser(false,true);
		Gui.jDialog8.setVisible(true);
	}
	
	
	/**
	 * Genera le connessioni tra tabelle basandosi sulle chiavi primarie 
	 * e i nomi dei campi
	 */
	public void createNameLink()
	{
		nameLinked = true;
		for (int i=0; i<jList.size(); i++)
			for (int a=0; a<((Table) (jList.get(i))).PrimaryKey.size(); a++)
			{
				for (int o=0; o<jList.size(); o++)
				{
					if (i!=o)
						for (int u=0; u<(((Table) (jList.get(o))).getModel().getSize()); u++)
						{
							boolean ok=true;
							for (int z=0; z<((Table) (jList.get(o))).PrimaryKey.size(); z++)
							{
								try
								{
									if (((String) ((Table) (jList.get(o))).PrimaryKey.get(z)).compareTo(((Table) (jList.get(o))).getModel().getElementAt(u).toString())==0) ok = false;
								} catch (Exception ex) {}
							}
							if (ok)
								try
							{
									if (((((Table) (jList.get(o))))
											.getModel())
											.getElementAt(u)
											.toString()
											.compareTo(((Table) (jList.get(i)))
													.PrimaryKey
													.get(a).toString())==0) 
									{
										((Table) jList.get(o)).ForeignKey.add(((Table) (jList.get(o))).getModel().getElementAt(u).toString());
										((Table) jList.get(o)).ForeignTable.add(((Table) (jList.get(i))).Title);
										((Table) jList.get(o)).ForeignPrimary.add(((Table) (jList.get(i))).PrimaryKey.get(a).toString());
									}
							} catch (Exception ex) {}
						}
				}
			}
		
		Gui.jDesktopPane.repaint();
		
	}
	
	
	/**
	 * Aggiorna i parametri di connessione con quelli specificati nell'interfaccia
	 */
	public void enterPreferences()
	{
		if (Gui.jComboBox.getSelectedItem().toString().compareTo("Postgres")==0)
		{
			DB_DRIVER = "org.postgresql.Driver";
			DB_URL = "jdbc:postgresql://"+Gui.jTextURL.getText();
			dbmode="";
		}
		if (Gui.jComboBox.getSelectedItem().toString().compareTo("Direct MS Access")==0)
		{
			DB_DRIVER = "sun.jdbc.odbc.JdbcOdbcDriver";
			DB_URL = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ="+Gui.jTextURL.getText().trim()+";DriverID=22;READONLY=false";
			dbmode="MSAccess";
		}
		DB_PASSWORD = Gui.jPasswordField.getText();
		DB_UTENTE = Gui.jTextUSER.getText();
		Gui.jMenu.setEnabled(true);
		Gui.jDialog.setVisible(false);
	}
	
	/**
	 * Apre e imposta le preferenze di connessione alla situazione corrente
	 * dei dati
	 */
	public void preferences()
	{
		Gui.jMenu.setEnabled(false);
		Gui.getJDialog();
		if (DB_DRIVER=="org.postgresql.Driver")
		{
			Gui.jComboBox.setSelectedItem("Postgres");
			Gui.jTextURL.setText(DB_URL.replaceAll("jdbc:postgresql://","")); 
		}
		Gui.jTextUSER.setText(DB_UTENTE);
		Gui.jDialog.setVisible(true);
	}
	
	/**
	 Il comparator per ordinare in maniera inversa.
	 */
	public class ReverseOrder implements Comparator
	{
		public int compare(Object o1, Object o2)
		{
			return (((Comparable) o1).compareTo(o2)*-1);
		}
	}
	
	

	/**
	 E' il comparator che permette l'ordinamneto per Cardinalit
	 */
	public class CardinalityOrder implements Comparator
	{
		public int compare(Object o1, Object o2)
		{
			if (o1.toString().split("\\(__\\)")[0].compareTo("")==0) return -1;
			if (o2.toString().split("\\(__\\)")[0].compareTo("")==0) return 1;
			Integer no1 = new Integer(o1.toString().split("\\(__\\)")[0].split(", ").length);
			Integer sno1 = new Integer(o1.toString().split("\\(__\\)")[1]);
			Integer no2 = new Integer(o2.toString().split("\\(__\\)")[0].split(", ").length);
			Integer sno2 = new Integer(o2.toString().split("\\(__\\)")[1]);
			if ((no1.intValue()==no2.intValue())&&(sno1.compareTo(sno2)!=0)) return sno1.compareTo(sno2);  
			else 
				if (no1.intValue()!=no2.intValue()) return no1.compareTo(no2);
				else return (((Comparable) o1).compareTo(o2));
		}
	}
	
	
	/**
	 * Ordina una tabella secondo il criterio specificato
	 * 
	 * @param table la tabella
	 * @param id il campo su cui applicare l'ordinamento
	 * @param type il tipo di ordinamento
	 * @param id2 il campo secondario per l'ordinamento
	 * @return la tabella ordinata in forma di array bidimensionale
	 */
	public Object[][] sortData(JTable table, int id, int type, int id2)
	{
		TableModel m = table.getModel();
		ArrayList value = new ArrayList(0);
		for (int i=0; i<m.getRowCount(); i++)
			if (type==3) value.add(new DataSorter(m.getValueAt(i,id)+"(__)"+m.getValueAt(i,id2),i));
			else
				if (type==4)
				{
					if (m.getValueAt(i,id).toString().compareTo("")==0) value.add(new DataSorter(new Integer(-1),i));
					else
						value.add(new DataSorter(new Integer(((Integer)m.getValueAt(i,id2)).intValue()*m.getValueAt(i,id).toString().split(", ").length),i));
				}
				else value.add(new DataSorter((Comparable) m.getValueAt(i,id),i));
		if (type==1) Collections.sort(value, new ReverseOrder());
		if (type==2) Collections.sort(value);
		if (type==3) Collections.sort(value, new CardinalityOrder());
		if (type==4) Collections.sort(value, new ReverseOrder());
		Object Data[][] = new Object[m.getRowCount()][m.getColumnCount()];
		for (int i=0; i<value.size(); i++)
		{
			int index = 0;
			index = ((DataSorter) value.get(i)).index;
			for (int a=0; a<m.getColumnCount(); a++)
				Data[i][a] = m.getValueAt(index,a);
		}
		return Data;
	}
	
	
	/**
	 * aggiorna la "forma" della constraint window a seconda del tipo di vincolo 
	 * che si sta specificando
	 */
	public void updateConstraintWindow()
	{
		if ((Gui.jComboBox1.getSelectedItem().toString().compareTo("Subset_of")==0)||
				(Gui.jComboBox1.getSelectedItem().toString().compareTo("Superset_of")==0)||
				(Gui.jComboBox1.getSelectedItem().toString().compareTo("Attribute_Superset_of")==0)||
				(Gui.jComboBox1.getSelectedItem().toString().compareTo("Attribute_Subset_of")==0))
		{
			if (Gui.jComboBox1.getSelectedItem().toString().contains("Attribute"))
			{
				Gui.jDialog12.setTitle("List of Attribute");
				Gui.jComboBox6.removeAllItems();
				Gui.jComboBox6.addItem("All Attribute");
				for (int i=0; i<AttributeTot.size(); i++)
					Gui.jComboBox6.addItem(new String ((String)AttributeTot.get(i)));
				Gui.jComboBox6.setSelectedIndex(0);
				createAttributeList();
			}
			else
			{
				Gui.jDialog12.setTitle("List of Item");
				Gui.jComboBox6.removeAllItems();
				Gui.jComboBox6.addItem("All Item");
				for (int i=0; i<ItemTot.size(); i++)
					Gui.jComboBox6.addItem(new String ((String)ItemTot.get(i)));
				Gui.jComboBox6.setSelectedIndex(0);
				createItemList();
			}
			if (Gui.jList3!=null) Gui.jList3.setVisible(true);
			if (Gui.jDialog12!=null) {Gui.jDialog12.setVisible(true); Gui.getJDialog12();}
			if (Gui.jComboBox6!=null) Gui.jComboBox6.setVisible(true);
			if (Gui.jScrollPane16!=null) Gui.jScrollPane16.setVisible(true);
		}
		else
		{
			if (Gui.jList3!=null) Gui.jList3.setVisible(false);
			if (Gui.jDialog12!=null) Gui.jDialog12.setVisible(false);
			if (Gui.jComboBox6!=null) Gui.jComboBox6.setVisible(false);
			if (Gui.jScrollPane16!=null) Gui.jScrollPane16.setVisible(false);
		}
		
		if ((Gui.jComboBox1.getSelectedItem().toString().compareTo("Subset_of")==0)||
				(Gui.jComboBox1.getSelectedItem().toString().compareTo("Superset_of")==0)||
				(Gui.jComboBox1.getSelectedItem().toString().startsWith("Lenght")))
		{
			Gui.jComboBox2.setEnabled(false);
			Gui.jLabel8.setEnabled(false);
		}
		else
		{
			Gui.jComboBox2.setEnabled(true);
			Gui.jLabel8.setEnabled(true);
		}
	}
	
	
	/**
	 L'insieme di operatori per il calcolo di funzioni matematiche
	 */
	public class Operator
	{
		float a=0;
		float b=0;
		float c=0;
		boolean first=true;
		public Float sum(Float arg)
		{
			a+=arg.floatValue();
			return new Float(a);
		}
		public Float range(Float arg)
		{
			if (first)
			{
				a=arg.floatValue();
				b=arg.floatValue();
			}
			first=false;
			min(arg);
			max(arg);
			return new Float(b-a);
		}
		public Float min(Float arg)
		{
			if (first) a = arg.floatValue();
			else if (arg.floatValue()<a) a=arg.floatValue();
			return new Float(a);
		}
		public Float max(Float arg)
		{
			if (first) b = arg.floatValue();
			else if (arg.floatValue()>b) b=arg.floatValue();
			return new Float(b);
		}
		public Float avg(Float arg)
		{
			a+=arg.floatValue();
			b++;
			return new Float(a/b);
		}
		
		public Float var(Float arg)
		{
			avg(arg);
			c+=arg.floatValue()*arg.floatValue();
			float navg2 = (a/b)*(a/b)*b; 
			float avg = (a/b);
			return new Float((c+navg2-2*avg*a)/b);
		}
		public Float std(Float arg)
		{
			Float p = var(arg);
			return new Float(Math.sqrt(p.floatValue()));
		}
		
		public Float lenght(Float arg)
		{
			return arg;
		}
		
	}
	
	
	/** 
	 * Esegue il Parsing una query SPQL di discretizzazione
	 * @param query la query SPQL 
	 */
	public void parseDiscretization(String query)
	{
		query = query.trim();
		int Method = -1;
		int Interval = 0;
		int SMethod = -1;
		String namefield = null;
		String namenewfield = null;
		String nametable = null;
		String intervalMethod = null;
		String smootingh = null;
		Table tmp = null;
		String[] number = null;
		int tmpf = -1;
		try
		{
			query = query.trim();
			namefield = query.split(" AS ",2)[0].replaceFirst("DISCRETIZE","").trim();
			namenewfield = query.split(" AS ",2)[1].split("\n",2)[0].trim();
			nametable = query.split("\nFROM",2)[1].split("\n",2)[0].trim();
			intervalMethod = query.split("\nIN",2)[1].split("BINS",2)[0].trim();
			smootingh = query.split("\nSMOOTINGH BY",2)[1].trim();
			if (smootingh.compareTo("BIN BOUNDARIES")==0) SMethod = 0;
			if (smootingh.compareTo("AVERAGE")==0) SMethod = 1;
			if (smootingh.compareTo("COUNT")==0) SMethod = 2;
			if (intervalMethod.contains("EQUALWIDTH")) {Method = 0; Interval= Integer.valueOf(intervalMethod.replace("EQUALWIDTH","").trim()).intValue();}
			else
				if (intervalMethod.contains("EQUALDEPTH")) {Method = 1; Interval= Integer.valueOf(intervalMethod.replace("EQUALDEPTH","").trim()).intValue();}
				else
				{
					intervalMethod = intervalMethod.replaceAll("\\(","");
					intervalMethod = intervalMethod.replaceAll("\\)","");
					intervalMethod = intervalMethod.trim();
					System.out.println(intervalMethod);
					number = intervalMethod.split(",");
					System.out.println(number.length);
					Method = 2;
					Interval = 1;
				}
			for (int i=0; i<jList.size(); i++)
				if (((Table) (jList.get(i))).Title.compareTo(nametable)==0) tmp=(Table) (jList.get(i));
			for (int i=1; i<tmp.getModel().getSize(); i++)
				if (tmp.getModel().getElementAt(i).toString().compareTo(namefield)==0) tmpf = i;
		} 
		catch (Exception ex) 
		{
			SMethod=-1;
			Method=-1;
			Interval=0;
		}
		if ((Method<0)||(Interval<=0)||(SMethod<0)||(tmp==null)||(tmpf==-1))
		{
			Gui.getJDialog5(ErrorMessage.get(5)+": \n Parameter Error");
			Gui.jDialog5.setVisible(true);
			System.out.println(Method+" "+SMethod+" "+Interval+" "+tmp.Title+" "+tmpf);
			return;
		}
		if (dbmode.compareTo("MSAccess")==0)
		{
			nametable = nametable.replaceAll("\\[","");
			nametable = nametable.replaceAll("\\]","");
		}
		Discretization = new ArrayList();
		if (Method==2)
			for (int i=0; i<number.length; i+=2)
			{
				double from = Double.valueOf(number[i].trim()).doubleValue();
				double to = Double.valueOf(number[i+1].trim()).doubleValue();
				createIntervalDiscretization(from,to,Interval,Method);
			}
		else
		{
			double from = ((FieldInfo)(((TableInfo) (cacheTableInfo.get(tmp.Title))).Field).get(tmp.getModel().getElementAt(tmpf))).min;
			double to = ((FieldInfo)(((TableInfo) (cacheTableInfo.get(tmp.Title))).Field).get(tmp.getModel().getElementAt(tmpf))).max;
			createIntervalDiscretization(from,to+1,Interval,Method);
		}
		di=new Discretizator();
		di.table=tmp;
		di.field =tmpf;
		di.Interval=(ArrayList) Discretization.clone();
		di.Info= (Hashtable) ((FieldInfo)(((TableInfo) (cacheTableInfo.get(tmp.Title))).Field).get(tmp.getModel().getElementAt(tmpf))).InfoGraph.clone();
		di.smootingh = SMethod;
		di.name=namenewfield;
		Discretization.clear();
		working++;
		di.start();
		if (Gui.jPanel10!=null) Gui.jPanel10.repaint();
		if (Gui.jPanel7!=null) Gui.jPanel7.repaint();
		if (Gui.jDialog9!=null) Gui.jDialog9.setVisible(false);
	}
	
	/**
	 * Disconnette Conquest dal DBMS..
	 * @param force se false disconnette solo nel caso di un tentativo di connessione attivo
	 * altrimenti forza la disconnessione in tutti i casi.
	 */
	public void disconnect(boolean force)
	{
		try
		{
			Gui.jTextPane2.setText("Disconnected");
			statement=null;
			connection=null;
			Gui.jWarning.clearWarning();
			if ((co!=null)&&(!co.stillworking)&&(!force)) return;
			if (co!=null) co.interrupt();
			Gui.jMenuItem.setText("Connect");
			for (int i=0; i<jList.size(); i++)
				Gui.jDesktopPane.remove((Table) jList.get(i));
			selJList=null;
			jList.clear();
			Gui.jDesktopPane.repaint();
			cacheTableInfo = new Hashtable();
			TransactionTot.clear();
			ItemTot.clear();
			AttributeTot.clear();
			From = null;
			Spql = null;
			if (InfoGraph!=null) InfoGraph.clear();
			Gui.jScrollPane5.setViewportView(Gui.getJTable1(null));
			Gui.jScrollPane6.setViewportView(Gui.getJTable2(null));
			Gui.jScrollPane1.setViewportView(Gui.getJTable(null,null));
			Gui.jTextPane.setText("");
			Gui.jTextPane4.setText("");
			Gui.jTextPane3.setText("");
			Gui.jButton38.setVisible(false);
			Gui.jMasterPanel.repaint();
			inverseParser();
			updateTableList();
		} catch (Exception ex) {}
	}
	
	
	/** Mantiene coerente la lista di vincoli eliminando quelli che si riferiscono
	 * ad attributi che non sono selezionati come tali.
	 * 
	 * @param idtable l'id della tabella selezionata
	 * @param attrib  il nome dell'attributo deselezioanto
	 */
	public void removeAttributeConstraint(int idtable,String attrib)
	{
		Object DataR[] = new Object[Gui.jList1.getModel().getSize()];
		int o=0;
		for (int i=0; i<Gui.jList1.getModel().getSize(); i++)
		{
			String tmp = Gui.jList1.getModel().getElementAt(i).toString();
			if (tmp.contains(((Table) jList.get(idtable)).Title+"."+attrib)==false)
			{
				DataR[o] = (Object) tmp;
				o++;
			}
		}
		Object Data[] = new Object[o];
		for (int i=0; i<o; i++) Data[i]=DataR[i];
		Gui.jList1.setListData(Data);
		Gui.jList1.repaint();
	}
	
	/** Mantiene coerente la lista delle risoluzione di conflitti degli attributi 
	 * eliminando quelli che si riferiscono ad attributi che non sono 
	 * selezionati come tali.
	 * 
	 * @param idtable l'id della tabella selezionata
	 * @param attrib  il nome dell'attributo deselezioanto
	 */
	public void removeAttributeResolve(int idtable,String attrib)
	{
		resolveAttribute.remove(((Table) jList.get(idtable)).Title+"."+attrib);
	}
	
	/**
	 * Gestisce il Pattern Browser
	 * 
	 * @param change se dopo la visualizzazione l'opzione dell'Item/Itemset View deve cambiare
	 * @param title il titolo della finestra
	 */
	public void visualBrowser(boolean change, boolean title)
	{
		if ((!change)&&(Gui.jMenuItem1.getText().compareTo(ItemView)==0)) Gui.jMenuItem1.setText(ItemsetView);
		else if ((!change)&&(Gui.jMenuItem1.getText().compareTo(ItemsetView)==0)) Gui.jMenuItem1.setText(ItemView);
		int maxString=0;
		if (Gui.jMenuItem1.getText().compareTo(ItemView)==0)
		{
			ArrayList result[] = new ArrayList[2];
			result[0] = new ArrayList(0);
			result[1] = new ArrayList(0);
			for (int i =0; i<cSPQL.Result.size(); i++)
			{
				String items[] = ((String)cSPQL.Result.get(i)).split(" ");
				for (int a=0; a<items.length-1; a++)
				{
					result[0].add(new Integer(i));
					result[1].add(items[a]);
				}
			}
			Object Data[][] = new Object[result[0].size()][2+cSPQL.Attribute.size()];
			for (int i=0; i<result[0].size(); i++)
			{
				Data[i][0]=result[0].get(i);
				Data[i][1]=cSPQL.MapItem.get(new Integer(result[1].get(i).toString()).intValue()).toString().replaceAll(Marker,"");
				if (maxString<Data[i][1].toString().length()) maxString =Data[i][1].toString().length(); 
				if (!browserNameMapping) Data[i][1] = ((String) Data[i][1]).split(":",2)[1];
				else if (cSPQL.From==1) Data[i][1] = ((String) Data[i][1]).split("\\.",2)[1];
				for (int o=0; o<cSPQL.Attribute.size();o++)
					if (cSPQL.MapAttribute.get
							(((ArrayList) cSPQL.Attribute.get(o)).get(new Integer(result[1].get(i).toString()).intValue()))!=null)
						Data[i][2+o]=cSPQL.MapAttribute.get(((ArrayList) cSPQL.Attribute.get(o)).get(new Integer(result[1].get(i).toString()).intValue()));
					else
						Data[i][2+o]=((ArrayList) cSPQL.Attribute.get(o)).get(new Integer(result[1].get(i).toString()).intValue());
			}
			Object Columns[] = new Object[2+cSPQL.Attribute.size()];
			Columns[0] = new String("id");
			Columns[1] = new String("item");
			for (int o=0; o<cSPQL.Attribute.size();o++)
				Columns[2+o]= cSPQL.AttributeLabel.get(o);
			
			
			Gui.jScrollPane7.setViewportView(Gui.getJTable3(Data,Columns));
			Gui.jScrollPane7.repaint();
			if (title) Gui.jDialog8.setTitle("Mining result: Pattern browser - "+Gui.jMenuItem1.getText());
			Gui.jMenuItem1.setText(ItemsetView);
			cSPQL.MaxLenght = maxString;
		}
		else
		{
			Object Data[][] = new Object[cSPQL.Result.size()][3+cSPQL.Constraint.size()];
			Object Columns[] = new Object[3+cSPQL.Constraint.size()];
			Columns[0]= new String("id");
			Columns[1]= new String("Frequent Itemset");
			Columns[2]= new String("Support");
			for (int ac=0; ac<cSPQL.Constraint.size(); ac++)
				try
			{
					Columns[3+ac] = cSPQL.Constraint.get(ac)+" "+cSPQL.AttributeLabel.get(((Integer) (cSPQL.IndexAttConstrain.get(ac))).intValue());
			} catch (Exception ex) {Columns[3+ac] = cSPQL.Constraint.get(ac);};
			for (int i =0; i<cSPQL.Result.size(); i++)
			{
				if (Gui.jProgressBar!=null) Gui.jProgressBar.setString("Read Result:"+i+"/"+cSPQL.Result.size());
				Data[i][0] = new Integer(i);
				try
				{
					Data[i][2] = new Integer(cSPQL.Result.get(i).toString().substring(cSPQL.Result.get(i).toString().indexOf("(")+1).replace(")",""));
				} catch (Exception ex) {Data[i][2]=new Integer(1);}
				String s = cSPQL.Result.get(i).toString().replaceAll(Marker,"");
				Object token[] = s.split(" ");
				Data[i][1]=new String("");
				float values[] = new float[cSPQL.Constraint.size()];
				Operator op[] = new Operator[cSPQL.Constraint.size()];
				for (int opn=0; opn<cSPQL.Constraint.size(); opn++)
					op[opn]=new Operator();
				String extra= new String();
				for (int t=0; t<token.length; t++)
					if (token[t].toString().compareTo("")!=0) 
					{
						for (int ac=0; ac<cSPQL.Constraint.size(); ac++)
						{
							Object arg[] = new Object[1];
							try
							{
								arg[0]= (Object) new Float(((String) ((ArrayList) cSPQL.Attribute.get(((Integer) (cSPQL.IndexAttConstrain.get(ac))).intValue())).get(new Integer(token[t].toString()).intValue())));
							} catch (Exception ex) {arg[0]=new Float(token.length);}
							try
							{
								values[ac] = ((Float) ((Method) (operator.get((String) cSPQL.Constraint.get(ac)))).invoke(op[ac],arg)).floatValue();
							} catch(Exception exce) {}
						}
						token[t] = cSPQL.MapItem.get(new Integer(token[t].toString()).intValue()).toString().replaceAll(Marker,"");;
						if (!browserNameMapping) token[t] = ((String) token[t]).split(":",2)[1];
						else if (cSPQL.From==1) token[t] = ((String) token[t]).split("\\.",2)[1];
						if (t!=token.length-1) extra = ", "; else extra = "";
						Data[i][1] = Data[i][1] + token[t].toString() + extra;
					}
				if (maxString<Data[i][1].toString().length()) maxString =Data[i][1].toString().length(); 
				for (int ac=0; ac<cSPQL.Constraint.size(); ac++)
					Data[i][3+ac] = new Double(values[ac]);
				
			}
			Gui.jScrollPane7.setViewportView(Gui.getJTable3(Data,Columns));
			Gui.jScrollPane7.repaint();
			if (title) Gui.jDialog8.setTitle("Mining result: Pattern browser - "+Gui.jMenuItem1.getText());
			Gui.jMenuItem1.setText(ItemView);
			cSPQL.MaxLenght= maxString;
		}
	}
	
	
	
	
	
	/**
	 * Crea gli intervalli di dicretizzazione a seconda del metodo selezionato
	 * tramite interfaccia o query SPQL.
	 * 
	 * @param from valore iniziale dell'intervallo da prendere in consideratione
	 * @param to valore finale dell'intervallo da prendere in considerazione
	 * @param s il nume di sezioni in cui dividere l'intervallo
	 * @param Method il metodo da utilizzare per la suddivisione
	 */
	public void createIntervalDiscretization(double from, double to, int s, int Method)
	{
		Object data[] = null;
		switch (Method)
		{
		case 0:
		{
			Discretization.clear();
			data = new Object[s];
			if (to<from) return;
			for (int i=0; i<s; i++)
			{
				Discretization.add(new Point2D.Double((from+((to-from)/((float) s))*i),(from+((to-from)/((float) s))*(i+1))));
				data[i] = new String("From: "+df.format((from+((to-from)/((float) s))*i))+" - To: "+df.format((from+((to-from)/((float) s))*(i+1))));
			}
			break;
		}
		case 1:
		{
			Discretization.clear();
			Enumeration en = InfoGraph.keys();
			ArrayList values = new ArrayList();
			Hashtable link = new Hashtable();
			data = new Object[s];
			int tot=0;
			while (en.hasMoreElements())
			{
				Object v = en.nextElement();
				Double value = Double.valueOf(v.toString());
				tot+=((Integer) InfoGraph.get(v)).intValue();
				values.add(value);
				link.put(value,((Integer) InfoGraph.get(v)));
			}
			Collections.sort(values);
			tot/=s;
			int totp=0;
			double limit = from;
			int p=0;
			for (int i=0; i<values.size(); i++)
			{
				totp+= ((Integer) link.get(values.get(i))).intValue();
				if (totp>=tot) 
				{
					int extra = 0;
					if (i==values.size()-1) extra=1;
					Discretization.add(new Point2D.Double(limit,((Double) values.get(i)).doubleValue()+extra));
					data[p] = new String("From: "+df.format(limit)+" - To: "+df.format(((Double) values.get(i)).doubleValue()+extra));
					limit = ((Double) values.get(i)).doubleValue();
					totp=0;
					p++;
				}
			}
			if (totp!=0)
			{
				Discretization.add(new Point2D.Double(limit,((Double) values.get(values.size()-1)).doubleValue()+1));
				data[p] = new String("From: "+limit+" - To: "+((Double) values.get(values.size()-1)).doubleValue()+1);
			}
			break;	
		}
		
		case 2:
		{
			if (to<from) return;
			if (Gui.jList2!=null)
			{
				data = new Object[Gui.jList2.getModel().getSize()+s];
				for (int i=0; i<Gui.jList2.getModel().getSize(); i++)
					data[i]=Gui.jList2.getModel().getElementAt(i);
			}
			for (int i=0; i<s; i++)
			{
				Discretization.add(new Point2D.Double((from+((to-from)/((float) s))*i),(from+((to-from)/((float) s))*(i+1))));
				if (Gui.jList2!=null) data[Gui.jList2.getModel().getSize()+i] = new String("From: "+df.format((from+((to-from)/((float) s))*i))+" - To: "+df.format((from+((to-from)/((float) s))*(i+1))));
			}
			break;
		}
		}
		ChangeGraph=true;
		if (Gui.jList2!=null) Gui.jList2.setListData(data);
		if (Gui.jPanel10!=null) Gui.jPanel10.repaint();
		if (Gui.jPanel7!=null) Gui.jPanel7.repaint();
	}
	
	/**
	 *  Imposta la modalit estesa a tutte le tabelle
	 */
	public void maximizeAll()
	{
		for (int i=0; i<jList.size(); i++)
		{
			Table tmp = ((Table) jList.get(i));
			maximizeTable(tmp);
		}
	}
	
	/**
	 *  Imposta la modalit ridotta a tutte le tabelle
	 */
	public void minimizeAll()
	{
		for (int i=0; i<jList.size(); i++)
		{
			Table tmp = ((Table) jList.get(i));
			minimizeTable(tmp);
		}
	}

	/** Imposta la modalit ridotta alla tabella
	 * @param tmp la tabella da impostare
	 */
	public void minimizeTable(Table tmp)
	{
		tmp.rollup=true;
		int size=tmp.getFontMetrics(tmp.getFont()).getHeight()+tmp.getFontMetrics(tmp.getFont()).getHeight()/3;
		tmp.setBounds(tmp.getX(),tmp.getY(),tmp.getWidth(),size);
		if (jListProperty.containsKey(tmp.Title)) ((Property) jListProperty.get(tmp.Title)).rollup = true;
	}
	
	/** Imposta la modalit estesa alla tabella
	 * @param tmp la tabella da impostare
	 */
	public void maximizeTable(Table tmp)
	{
		tmp.rollup=false;
		int size=tmp.getFontMetrics(tmp.getFont()).getHeight()*tmp.getModel().getSize();			
		tmp.setBounds(tmp.getX(),tmp.getY(),tmp.getWidth(),size);
		if (jListProperty.containsKey(tmp.Title)) ((Property) jListProperty.get(tmp.Title)).rollup = false;
		
	}
	
	
	
	/**
	 Il filtro per la selesione di file con estenzione specificata
	 */
	public class ExtFileFilter extends FileFilter
	{
		String ext = "";
		
		public ExtFileFilter(String ext)
		{
			this.ext="."+ext;
		}
		
		public boolean accept(File f) {
			if (f.isDirectory()) {
				return true;
			}
			String extension = f.getName().substring(f.getName().lastIndexOf("."),f.getName().length());
			if (extension != null) {
				if (extension.equalsIgnoreCase(ext))
					return true;
				else 
					return false;
			}
			return false;
		}
		
		public String getDescription() {
			return ext+" file";
		}
	}
	
	/**
	 Genera l'elenco di Item esistenti per le constraint che necessitano di una
	 selezione di un insieme di valori
	 */
	public void createItemList()
	{
		if (Gui.jComboBox6.getSelectedItem()==null) return;
		ArrayList raw = new ArrayList();
		if (Gui.jComboBox6.getSelectedIndex()==0)
		{
			try
			{
				for (int i=0; i<jList.size();i++)
					for (int a=0; a<((Table) jList.get(i)).Item.size();a++)
						for (int o=0; o<((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Columns.length; o++)
							if (((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Columns[o].toString().compareTo(((Table) jList.get(i)).Item.get(a).toString())==0)
								for (int p=0; p<((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Data.length; p++)
								{
									String text = ((Table) jList.get(i)).Title+"."+((Table) jList.get(i)).Item.get(a)+":"+((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Data[p][o];
									if (!raw.contains(text)) raw.add(text);
								}
			} catch (Exception ex) {ex.printStackTrace();}
		}
		else
		{
			try
			{
				for (int i=0; i<jList.size();i++)
					for (int a=0; a<((Table) jList.get(i)).Item.size();a++)
						if ( (((Table) jList.get(i)).Title.compareTo(Gui.jComboBox6.getSelectedItem().toString().split("\\.",2)[0])==0) &&
								(((Table) jList.get(i)).Item.get(a).toString().compareTo(Gui.jComboBox6.getSelectedItem().toString().split("\\.",2)[1])==0))
							for (int o=0; o<((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Columns.length; o++)
								if (((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Columns[o].toString().compareTo(Gui.jComboBox6.getSelectedItem().toString().split("\\.",2)[1])==0)
									for (int p=0; p<((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Data.length; p++)
									{
										String text = ((Table) jList.get(i)).Title+"."+((Table) jList.get(i)).Item.get(a)+":"+((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Data[p][o];
										if (!raw.contains(text)) raw.add(text);
									}
			} catch (Exception ex) {ex.printStackTrace();}
		}
		
		if (Gui.jComboBox6.getSelectedIndex()==0) 
			Gui.jList3.setListData(raw.toArray());
		else
		{
			Object[] Data = new Object[raw.size()];
			for (int i=0; i<raw.size();i++)
				Data[i] = raw.get(i).toString().split("\\:",2)[1];
			Gui.jList3.setListData(Data);
		}
		Gui.jDialog1.repaint();
	}
	
	/**
	 Genera l'elenco di Attributi esistenti per le constraint che necessitano di una
	 selezione di un insieme di valori
	 */
	public void createAttributeList()
	{
		if (Gui.jComboBox6.getSelectedItem()==null) return;
		ArrayList raw = new ArrayList();
		if (Gui.jComboBox6.getSelectedIndex()==0)
		{
			try
			{
				for (int i=0; i<jList.size();i++)
					for (int a=0; a<((Table) jList.get(i)).Attribute.size();a++)
						for (int o=0; o<((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Columns.length; o++)
							if (((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Columns[o].toString().compareTo(((Table) jList.get(i)).Attribute.get(a).toString())==0)
								for (int p=0; p<((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Data.length; p++)
								{
									Object text = ((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Data[p][o];
									if (!raw.contains(text)) raw.add(text);
								}
			} catch (Exception ex) {ex.printStackTrace();}
		}
		else
		{
			try
			{
				for (int i=0; i<jList.size();i++)
					for (int a=0; a<((Table) jList.get(i)).Attribute.size();a++)
						if ( (((Table) jList.get(i)).Title.compareTo(Gui.jComboBox6.getSelectedItem().toString().split("\\.",2)[0])==0) &&
								(((Table) jList.get(i)).Attribute.get(a).toString().compareTo(Gui.jComboBox6.getSelectedItem().toString().split("\\.",2)[1])==0))
							for (int o=0; o<((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Columns.length; o++)
								if (((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Columns[o].toString().compareTo(Gui.jComboBox6.getSelectedItem().toString().split("\\.",2)[1])==0)
									for (int p=0; p<((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Data.length; p++)
									{
										String text = ((Table) jList.get(i)).Title+"."+((Table) jList.get(i)).Attribute.get(a)+":"+((TableInfo) cacheTableInfo.get(((Table) jList.get(i)).Title)).Data[p][o];
										if (!raw.contains(text)) raw.add(text);
									}
			} catch (Exception ex) {ex.printStackTrace();}
		}
		
		if (Gui.jComboBox6.getSelectedIndex()==0) 
			Gui.jList3.setListData(raw.toArray());
		else
		{
			Object[] Data = new Object[raw.size()];
			for (int i=0; i<raw.size();i++)
				Data[i] = raw.get(i).toString().split("\\:",2)[1];
			Gui.jList3.setListData(Data);
		}
		Gui.jDialog1.repaint();
	}
	
	
	
	/**
	 * Genera le ragole a partire dal dataset correntemente in analisi
	 * @param mconf la confidenza minima delle regole da visualizzare
	 */
	public void generateRules(double mconf)
	{
		currentRulesMaxLenght=0;
		String code = Integer.valueOf(Double.valueOf(mconf).hashCode()).toString();
		pr = new Exec();
		pr.command = "RULE.exe "+cSPQL.NameResult+".result"+" "+mconf+" "+cSPQL.NameResult+"C"+code+".rules";
		pr.start();
		while (pr.isAlive()) {}
		BufferedReader br=null;
		FileReader r=null;
		ArrayList raw = new ArrayList(0);
		try {
			r=new FileReader(cSPQL.NameResult+"C"+code+".rules");
			br=new BufferedReader(r);
		} catch(Exception e) {e.printStackTrace();}
		String c="";
		try {
			do {
				c=br.readLine();
				if (c!=null) raw.add(c);
			} while (c!=null);
			r.close();
		} catch(Exception e) {e.printStackTrace();}
		int n = 0;
		for (int i=0; i<raw.size(); i++)
			if (!((String) raw.get(i)).contains("Inf")) n++;
		Object[][] Data = new Object[n][5];
		Object[] Columns = new Object[5];
		Columns[0] = "Id";
		Columns[1] = "Body";
		Columns[2] = "Head";
		Columns[3] = "Support";
		Columns[4] = "Confidence";
		int p = 0;
		for (int i=0; i<raw.size(); i++)
		{
			String cur = (String) raw.get(i);	
			if (!cur.contains("Inf"))
			{
				try
				{
					cur = cur.trim();
					cur = cur.replace("\n","");
					String[] headtail_supp = cur.split("\\(");
					String[] head_tail = headtail_supp[0].split("=>");
					String[] head = head_tail[0].split(" ");
					String[] tail = head_tail[1].split(" ");
					String[] supp_conf = headtail_supp[1].split(", ");
					supp_conf[1] = supp_conf[1].substring(0,supp_conf[1].length()-1);
					Data[p][0]= new Integer(p); 
					cur="";
					for (int o=0; o< head.length; o++)
					{
						//System.out.println("head:"+ head[o]);
						cur+=(String) cSPQL.MapItem.get(Integer.valueOf(head[o]).intValue()).toString().replaceAll(Marker,"");
						if (o!=head.length-1) cur+=", ";
					}
					Data[p][1]=cur; 
					if (currentRulesMaxLenght<cur.length()) currentRulesMaxLenght = cur.length(); 
					cur="";
					for (int o=1; o< tail.length; o++)
					{
						//System.out.println("tail:"+tail[o]);
						cur+=(String) cSPQL.MapItem.get(Integer.valueOf(tail[o]).intValue()).toString().replaceAll(Marker,"")+" ";
						if (o!=tail.length-1) cur+=", ";
					}
					Data[p][2]=cur; 
					if (currentRulesMaxLenght<cur.length()) currentRulesMaxLenght = cur.length(); 
					Data[p][3]= new Integer(supp_conf[0]); 
					Data[p][4]= new Double(supp_conf[1]); 
					p++;
				} catch (Exception ex) {ex.printStackTrace();}
			}
		}
		Gui.getRules();
		Gui.jFrame.setVisible(true);
		Gui.jLabel26.setText("Minimum Confidence: "+mconf);
		Gui.jScrollPane17.setViewportView(Gui.getJTable5(Data,Columns));
		
		/*System.out.println("data:");
		 for (int i=0; i<Data.length; i++)
		 for (int o=0; o<Data[i].length; o++)
		 System.out.println(Data[i][o]);
		 System.out.println("columns:");
		 for (int i=0; i<Columns.length; i++)
		 System.out.println(Columns[i]);
		 */
		
		Gui.jScrollPane17.repaint();
	}
	

	
	/**
	 * Aggiorna la Tabe List
	 */
	public void updateTableList() {
		Object[] data = new Object[jList.size()];
		for (int i=0; i<jList.size(); i++)
			data[i] = ((Table) jList.get(i)).Title;
		Gui.jList4.setListData(data);
		Gui.jList4.repaint();
	}
	
	
	public static void main(String[] args) {
		new Conquest();
	}
	
	/**
	 Costruttore che istanzia l'interfaccia e la inizializza
	 */
	public Conquest() {
		super();
		Gui = new Interface();
		Gui.initialize(this);
	}
	
}  
