package Conquest;

import java.awt.Point;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Hashtable;

import javax.swing.JList;

/**
 * Contiene i tipi utilizzati dal control per la gestione delle tabelle e del processo 
 * di mining.
 * 
 */
public class Type {

	/**
	 * Un oggetto che contiene tutti i dati di uno specifico campo di una tabella
	 *
	 */
	public class FieldInfo implements Serializable {
		private static final long serialVersionUID = -1217408020359487042L;

		public FieldInfo() {
		}

		public double min = 0;

		public double max = 0;

		public double avg = 0;

		public boolean nr = false;

		public Hashtable InfoGraph = null;

		public float MaxGraph = 0;

		public ArrayList Discretization = null;
	}

	/**
	 * Un oggetto che contiene tutti i dati di una esecuzione della ricerca di mining
	 *
	 */
	public class CurrentSPQLExecution
	{
		public String query = null;
		public ArrayList Result = null;
		public ArrayList Attribute = null;
		public Hashtable MapAttribute = null;
		public ArrayList MapItem = null;
		public ArrayList Constraint = null;
		public ArrayList IndexAttConstrain = null;
		public ArrayList AttributeLabel = null;
		public String NameResult = null;
		public int From = 0;
		public int NTransacrion = 0;
		public int MaxLenght = 0;
		
	}
	
	
	/**
	 * Un oggetto che contiene tutti i dati di una tabella
	 *
	 */
	public class TableInfo implements Serializable {
		private static final long serialVersionUID = 7504019825878840479L;

		public TableInfo() {
		}

		public Hashtable Field = new Hashtable(0);

		public int nelements = 0;

		public ArrayList nametype = new ArrayList(0);

		public Object Data[][] = null;

		public Object Columns[] = null;

		public boolean recalculate = false;

		public String listType = null;

	}

	/**
	 * Le propriet di visualizzazione iniziale di una tabella
	 *
	 */
	public class Property {
		public Point location = null;

		public boolean rollup = false;

		public boolean visible = true;
	}

	
	/**
	 * Tutti i metadati di una tabella caricata
	 *
	 */
	public class Table extends JList {
		public ArrayList PrimaryKey = new ArrayList(); 

		public ArrayList ForeignKey = new ArrayList(); 

		public ArrayList ForeignTable = new ArrayList(); 

		public ArrayList ForeignPrimary = new ArrayList(); 

		public ArrayList UnivocKey = new ArrayList();

		public String Title = "";

		public ArrayList Transaction = new ArrayList();

		public ArrayList Item = new ArrayList();

		public ArrayList Attribute = new ArrayList();

		public boolean rollup = false;

		public boolean conflict = false;

		public int created = 0;
	}

}
